%	File: fhpsstr.s		(core)
%
%	Altsys Corporation Proprietary Information - copyright 1992.
%	For internal use only. Disclosure or transfer to unauthorized persons
%	prohibited. This computer software is protected under copyright law as an
%	unpublished work.  All rights reserved.
%
%	Abstract:
%
%		all PS strings for printing/display in Virty.
%
%	TODO:
%		-- change texturefills to use PATmp/PATsp instead of their own stuff
%		-- speed up im string building for grad fills
%		-- remove color array stuff to save vm (yeah, right)
%
%  	Revision history:
%	920128	Now has a revision history. (srj)
%	920424	At the request of Ole Kvern, 'vc' now defines
%			the color in the small var 'cvc' (current virty color),
%			so that user PS effects can look at the current color
%			and determine info about spot vs. process. (srj)
%	920506	added registration color support. (srj)
%	920714	changed the error-handler so that we only print the
%			first error code. this prevents cascading errors
%			from outputting a zillion pages. (srj)
%	920730	renamed 'overprintprocess' to 'overprintcmyk'
%			to avoid naming conflicts with FH3 eps, since
%			the arguments to this operator are different now. (srj)
%

q
####
Q
####
[^0] ^1 d
####
^2 M
####
^3 w
####
^4 j
####
^5 J
####
true setoverprint
####
false setoverprint
####
^6 O
####
^7 R
####
vms
####
vmrs
####
vmr
####
^8 i
####
^9 concat
####
true eomode
####
false eomode
####
true
####
false
####
 vc
####
 K
####
 k
####
 X
####
 x
####
m
####
L
####
C
####
h
####
n
####
W
####
^0 ^1 translate
####
F	% fill
####
f	% close, then fill
####
S	% stroke
####
s	% close, then stroke
####
fas
####
sas
####
^1 <^0> pF	% pattern fill
####
^1 <^0> pf	% close, then  pattern fill
####
^1 <^0> pS % pattern stroke
####
^1 <^0> ps	% close, then  pattern stroke
####
^0 ^1 ^2 ^3 ^4 ^5 rfs
####
^0 ^1 ^2 ^6 ^7 rfp
####
^4 ^5 ^6 ^0 ^1 ^2 ^3 lfs
####
^7 ^8 ^0 ^1 ^2 ^3 lfp
####
/normtaper load
####
/logtaper load
####
^R % frequency
^S % angle
^T % proc
setscreen
####
showpage
####
^0 ^1 ^2 ^3 ^4 (^5) `
%%BeginDocument: ^5
####
%%EndDocument
end -save0- restore % AltsysDict begin

% no longer pop/push AltsysDict for eps

% ------------------------------
% strings used for font handling
%-------------------------------
####
%%ChangeFont: ^0
####
%%IncludeFont: ^0
####
f^1 ^2 makesetfont
####
^3 dict dup begin
####
end
####
/f^1 /^0 FF def

%-----------------------------
% strings used for text PS gen
%-----------------------------
####
^3 32 ^4 (^5) ts
####
{
####
}
####
% show text - normal!
sts
####
%--------------------------
% custom text effects code
%--------------------------
% dup
dup
####

% show text - oblique
% textblock color -- Obsolete JBA
%. unused
####

% show text - shadow
% textblock color --
/stsh{
	/ts{
		curtextheight .06 mul dup neg rmoveto awidthshow
		curtextheight .06 mul neg dup neg rmoveto
	}def											% std fcn, we just fiddle pos & screen
	gsave 
% this is evil... changing the screen capriciously is very, very, very bad.
% if the user really wants a bad-looking screen, let them.
%	currentscreen 3 -1 roll 						% check if screen is fine enough
%	100 ge{pop pop}{100 3 1 roll setscreen}ifelse	% set to 100 lines or better
	[0 0 0 .5] vc									% black sep only
	1 index exec 									% do first pass in gray
	grestore
	/ts{awidthshow}def		% back to normal show
	settextcolor exec
}bdf		% finish up in color

####

% show text - fill & stroke
% textblock fillcolor strokecolor strokewidth filloverprint 
% fillflag strokeoverprint strokeflag miterlimit--
/stfs1{ 
	/textblackopf false def
	/miter_lim xdf 
	4 -2 roll 0 ne
	{0 ne/textopf xdf 5 index 5 index sts}{pop}ifelse 
	5 -1 roll pop
	% textblock strokecolor strokewidth strokeoverprint strokeflag --
	0 ne
	{0 ne/textopf xdf 1.0 miter_lim 2 div sin div M stol}
	{pop pop pop pop}ifelse 
	false setoverprint /textopf false def /textblackopf true def
}bdf

####

% show text - zoom
% ---------- extrude text ----------

% textblock, left, bottom, right, top, to color, from color, 
% xoffset, yoffset, minext
/extrude
{ 
  /chg xdf /deltay xdf /deltax xdf  
  /tc1 xdf storerect /tc2 xdf
  /factor .95 def
  newpath
  % put color in process form since text dialogs don't have
  % trapping capability for inappropriate color combinations
  % (easiest solution for now)
  tc1 length 2 eq 
  {/tc1 tc1 spottoprocess def} if  
  tc2 length 2 eq 
  {/tc2 tc2 spottoprocess def} if  
  /cnt todraw def  
  /ts  % redefine 'ts' - scale about ctr of text bounding box, 
       % then offset back to start of text, then show it
  {gsave currentpoint pop /xstart xdf blockxoff wordxoff add yoff 
   rmoveto scalef dup scale right left sub 2 div xstart left sub sub
   neg curtextheight 2 div neg rmoveto awidthshow grestore}def
  % execute proc in loop, drawing text 'todraw' times
  1 1 todraw div neg 0
  { % make sure we can get white
	dup .02 le{pop 0}if /frac xdf 
	gsave 
	% produce blended color
	0 1 3
	{
		bc4 exch			% set up for put at end: /bc i --
		tc1 1 index get		% bc i tc1[i] --
		tc2 2 index get		% bc i tc1[i] tc2[i] --
		1 index sub			% bc i tc1[i] delta[i] --
		frac mul add put	% stuff tc1[i]' into bc[i]
	}for 
	bc4 vc	% set it
	dup exec % execute the proc on stack
	cnt 1 ne{grestore}if  
	/cnt cnt 1 sub def  
  } for 
  % finish by drawing foremost text, filled with 'from' color,
  % outlined with 'to' color
  /ts{gsave awidthshow grestore}def % no need for meas. complexities now
  tc1 settextcolor dup exec tc2 settextcolor 
  % set stroke width as percentage of text size (.5 pt. wide at 100 pt. text)
  curtextheight .005 mul setlinewidth
  /ts {{false charpath stroke}ta} def exec 
  grestore
}bdf

/blockxoff  % calc x offset from currentpoint relative to whole text block
{right left sub 2 div currentpoint pop left sub sub}def 

/yoff  % calc y offset from currentpoint
{curtextheight 2 div deltay todraw div cnt mul add}def
 
/wordxoff  % calc x offset from currentpoint relative to sub-portion 
		   % of whole text block
{deltax todraw div cnt mul}def

/todraw  % #of extrusion elements to draw
{ deltax dup mul deltay dup mul add sqrt factor mul
  100 chg sub abs factor mul add 
  dup 0 le{pop 1}{round}ifelse} def

/scalef  % scale factor
{100 chg sub abs 100 div todraw div cnt mul
 chg 100 ge{1 add}{1 exch sub}ifelse}def

% spot_color -- process_color
% takes spot color, with tint, and converts it to tinted process color
/spottoprocess
{aload pop spots exch get aload pop pop pop % -- tint c m y k
0 1 3{pop 4 index mul 4 -1 roll}for		% -- c' m' y' k'
4 array astore exch pop}bdf

####

% show text - inline
% textblock, filltext color, stroke color, bg stroke, fg stroke, iterations, miter limit
/inlin
{ /miter_lim xdf /iterations xdf  /fgstroke xdf  /bgstroke xdf
  /tc2 xdf  /tc1 xdf /textblock xdf
1.0 miter_lim 2 div sin div M
{
	/textblock load tc1 fgstroke bgstroke add iterations mul stol
	/textblock load tc2 fgstroke bgstroke add iterations mul fgstroke sub stol
	/iterations iterations 1 sub def iterations 0 eq {exit} if
} loop
/textblock load false tc1 sts
} bdf

###### optional operators for patterned fills/lines
%-----------------------------------------------------------------------
% patterned fill operators -- interface to to the pattern glue.
%-----------------------------------------------------------------------

/fhpatdict 10 dict def
fhpatdict begin
	/PatternType 1 def
	/PaintType 2 def	% uncolored
	/TilingType 1 def
	/BBox [0 0 8 8] def
	/XStep 8 def
	/YStep 8 def
	/PatMtx [1 0 0 -1 0 8] def
	/PaintProc
		{begin 8 8 true PatMtx {PatData} imagemask end} bdf
	%/Implementation may be inserted by PS
	%/PatData will be inserted by us
end

% color pattern --
/pF{
	gsave 1 setgray filler grestore
	fhpatdict /PatData 3 -1 roll put	% define the pat data
	save exch
% this forces the pattern to always be 72 dpi, axis-aligned.
% to allow for "external" scaling, set matrix to origmtx.
% to let them be freely transformed, just remove this line.
	matrix defaultmatrix setmatrix
	fhpatdict matrix PATmp PATsp 
	/clipper load /eoclip load eq PATfill
	restore
}bdf

/pf{closepath pF}bdf

% color pattern --
/pS{
	gsave 1 setgray stroke grestore
	fhpatdict /PatData 3 -1 roll put	% define the pat data
	save exch					
	PATprestroke				
% this forces the pattern to always be 72 dpi, axis-aligned.
% to allow for "external" scaling, set matrix to origmtx.
% to let them be freely transformed, just remove this line.
	matrix defaultmatrix setmatrix
	fhpatdict matrix PATmp PATsp 
	PATstroke
	restore
}bdf

/ps{closepath pS}bdf

################ operators for text!

%-----------------------------------------------------------------------
% text effects 
% Most of these define an executable function 'ts', which the text
% gen part of Altsys pumps out to show a run of text. By redefining
% 'ts', we can control how the text block is drawn.
%-----------------------------------------------------------------------

% text overprint flag
/textopf false def

% flag: always overprint black text?
/textblackopf true def

% saved text matrix for scaling
/curtextmtx{}def

% width for outlined text
/otw .25 def

% Define helper for makesetfont & oblique effects.
% font_obj matrix --
/msf{dup/curtextmtx xdf makefont setfont}bdf

% this saves off the current text mtx so effects can get to it & sets up font
% font_obj matrix --
/makesetfont/msf load def

% this is a function which returns the current text height
% -- height
/curtextheight{.707104 .707104 curtextmtx dtransform
	dup mul exch dup mul add sqrt}bdf

% text awidthforall: for each char in a string, execute a function
% cx cy char ax ay string fcn --
/ta{1 index						% get string
{tempstr 0 2 index put tempstr 2 index 
gsave exec grestore				% perform function on char
tempstr stringwidth rmoveto		% advance by char width
5 index eq{6 index 6 index rmoveto}if		% extra space
3 index 3 index rmoveto			% normal space
}forall 7{pop}repeat}bdf

% show text - standard
% textblock overprint color --
/sts{settextcolor textopf or setoverprint
 	/ts{awidthshow}def exec false setoverprint}bdf

% show text - outline
% textblock color width --
/stol{/xt currentlinewidth def 	% save the old line width
	setlinewidth settextcolor textopf setoverprint newpath	% newpath dumps previous fig path
	/ts{{false charpath stroke}ta}def exec 
	false setoverprint xt setlinewidth}bdf	% restore old line width
	
% stroke text
% textblock overprint color --
/strk{settextcolor textopf or setoverprint
	/ts{{false charpath stroke}ta}def exec 
	false setoverprint
	}bdf	

% ----------------------------------------------------------------
% ----------------------------------------------------------------
% ----------------------------------------------------------------
######## beginning of the strings used to output our EPS header
%!PS-Adobe-2.0 EPSF-1.2
%%Title: ^0
%%Creator: ^3
%%CreationDate: ^1
%%BoundingBox: ^2

###### program specific header comments

%%FHPathName: ^4
%%DocumentProcSets: Altsys_header 4 0
%%DocumentSuppliedProcSets: Altsys_header 4 0

######

%%ColorUsage: Color

######

%%DocumentProcessColors: Cyan Magenta Yellow Black

######

%%DocumentCustomColors: (^1)

######

%%+ (^1)

######

%%CMYKCustomColor: ^0 (^1)

#####

%%CMYKProcessColor: ^0 (^1)

######

%%+ ^0 (^1)

######

%%DocumentFonts: ^0

######

%%DocumentNeededFonts: ^0

######

%%+^0

######

%%EndComments

######

AltsysDict begin

######

end %. AltsysDict

##### Beginning part of our Document Prolog.

%%BeginProcSet: Altsys_header 4 0

/AltsysDict 233 dict def
AltsysDict begin

% bdf: bind, then define
/bdf{bind def}bind def

% xdf: exch, then define
/xdf{exch def}bdf

% defed: like where but don't give me the darn dict
/defed{where{pop true}{false}ifelse}bdf

% ndf: define if not already defined
/ndf{1 index where{pop pop pop}{dup xcheck{bind}if def}ifelse}bdf

/d{setdash}bdf
/h{closepath}bdf
/H{}bdf
/J{setlinecap}bdf
/j{setlinejoin}bdf
/M{setmiterlimit}bdf
/n{newpath}bdf
/N{newpath}bdf
/q{gsave}bdf
/Q{grestore}bdf
/w{setlinewidth}bdf
% sepdef: define key in topmost dictionary that it already exists in.
% if it does not exist anywhere, define in AltsysSepDict
% sepdef: value key --
/sepdef{
	dup where not
	{
		AltsysSepDict
	}
	if	% stack: value key dict
	3 1 roll exch put
}bdf

/st{settransfer}bdf

% see if there is a colorimage operator already defined.
% if not, we will optimize our grad operators to just go thru
% image directly, rather than our bogus simulation of it,
% since our simulated one is really slow. If it is already
% defined, we better use it since we could be inside
% separations. Exception: check for the bogus Mac md
% define and ignore him!
% _rci: "real colorimage"
/colorimage defed /_rci xdf
/md defed{	% if md is present
	md type /dicttype eq {		% and it's a dict

		% check for some dopey things in md.
		/colorimage where {		% and colorimage is defined
			md eq {				% and it's defined in md
				/_rci false def	% then it's not really defined!
			}if
		}if

		% apple defines "settransfer" to concat procs, 
		% apparently for really stupid apps who don't
		% know any better. we are smarter than this,
		% so we'll just use the decent version:
		/settransfer where {
			md eq {
				/st systemdict /settransfer get def
			}if
		}if
	}if 
}if

% use device rounding for high quality printing
/setstrokeadjust defed
{
	true setstrokeadjust
	/C{curveto}bdf
	/L{lineto}bdf
	/m{moveto}bdf
}
{
	/dr{transform .25 sub round .25 add 
		exch .25 sub round .25 add exch itransform}bdf
	/C{dr curveto}bdf
	/L{dr lineto}bdf
	/m{dr moveto}bdf
	/setstrokeadjust{pop}bdf	% define it, please
}ifelse

% emulate the rectxxxx routines if not present.
% note: since these actually paint, it is very important
% to do the definitions with def, NOT bdf, in case
% fill, etc get redefined in a sep header.
/rectstroke defed /xt xdf
xt {/yt save def} if
/privrectpath {	% x y w h. do fancy stuff to ensure a counterclockwise path.
	4 -2 roll m
	dtransform round exch round exch idtransform	% stroke adjust
	2 copy 0 lt exch 0 lt xor
	{dup 0 exch rlineto exch 0 rlineto neg 0 exch rlineto}
	{exch dup 0 rlineto exch 0 exch rlineto neg 0 rlineto}
	ifelse
	closepath
}bdf
/rectclip{newpath privrectpath clip newpath}def
/rectfill{gsave newpath privrectpath fill grestore}def
/rectstroke{gsave newpath privrectpath stroke grestore}def
xt {yt restore} if

/packedarray{array astore readonly}ndf

% Ill 88 eps operators. note that ` assumes that the AltsysDict is the topmost
% dict on the stack when it is executed. Also note that ~ had better not be defined
% in AltsysDict, since it must be executed when AltsysDict is not active.
/`	% matrix llx lly urx ury string ` -
{	false setoverprint		% this is always defined in AltsysDict
	% no longer pop/push AltsysDict for eps
	% end %. AltsysDict
	/-save0- save def
	pop pop pop pop pop
	concat
	userdict begin
	/showpage {} def
	0 setgray 0 setlinecap 1 setlinewidth
	0 setlinejoin 10 setmiterlimit [] 0 setdash newpath
	false setstrokeadjust
} bdf

% note: the EPS-end operator "~" is now gone; you should now include
% it inline as: "end -save0- restore"

% turn on packing
/currentpacking defed{true setpacking}if

% n1 n2 -- min(n1,n2)
/min{2 copy gt{exch}if pop}bdf

% n1 n2 -- max(n1,n2)
/max{2 copy lt{exch}if pop}bdf

/xformfont { currentfont exch makefont setfont } bdf

% this is the currently "adobe-blessed" way of finding the 
% num of colors for setcolortransfer
/fhnumcolors 1                 
	statusdict begin
		/processcolors defed 
		{
			pop processcolors
		}
		{
			/deviceinfo defed {
				deviceinfo /Colors known {
					pop deviceinfo /Colors get
				} if
			} if
		} ifelse
	end % statusdict
def

%/calcgraysteps 256 def		% gray increment = 1/256
% we now calculate this based on printer resolution (pumped out
% (from the PPD) and screen frequency and angle, by a formula
% obtained from Adobe. NOTE: this does not always produce the "correct"
% answer; the actual number of grays is dependent on the number of pixels
% in the halftone cell, which depends on a lot of secret state-type things
% (according to Adobe). However, it does generally give us a pretty good guess.
% 	dist = print res / screen lpi
%	y = round(dist * sin(angle))
%	x = round(dist * cos(angle))
%	pix = x^2 + y^2
%
% decide what resolution this printer is...
/printerRes 
	gsave
	matrix defaultmatrix setmatrix
	72 72 dtransform
	abs exch abs
	max
	grestore
	def

% all these procs are supposed to put 'angle frequency' on the stack
/graycalcs
[
	{Angle Frequency}			% type 1
	{GrayAngle GrayFrequency}	% type 2
	{0 Width Height matrix defaultmatrix idtransform 
		dup mul exch dup mul add sqrt 72 exch div}	% type 3
	{0 GrayWidth GrayHeight matrix defaultmatrix idtransform 
		dup mul exch dup mul add sqrt 72 exch div}	% type 4
] def

% -- calcgraysteps numsteps
/calcgraysteps {
	/currenthalftone defed
	{
		currenthalftone begin
			HalftoneType 4 le
			{graycalcs HalftoneType 1 sub get exec}
			{
				HalftoneType 5 eq
				{
					Default begin
						{graycalcs HalftoneType 1 sub get exec}
					end
				}
				{0 60}	% something weird!
				ifelse
			}
			ifelse
		end
	}
	{
		currentscreen pop exch			% stack: angle freq
	}
	ifelse

	printerRes 300 max exch div exch	% stack: dist angle (note: NOT idiv!)
	2 copy								% stack: dist angle dist angle
	sin mul round dup mul				% stack: dist angle y^2
	3 1 roll							% stack: y^2 dist angle
	cos mul round dup mul				% stack: y^2 x^2
	add 1 add							% stack: grays
	dup maxsteps gt {pop maxsteps} if		% stack: clippedgrays
} bdf

% truly evil, sleazy hack: since NS2.0 incorrectly defines
% deviceinfo, we temporarily hack around it thusly.
% it also has a bug such that calling currentscreen and/or
% currenthalftone crashes the window server! In that
% case, we just redefine calcgraysteps to be stupid...
/nextrelease defed {						% if on a next...
	/languagelevel defed not {				% and not level 2...
		/framebuffer defed {				% and a color device...
			0 40 string framebuffer 9 1 roll 8 {pop} repeat
			dup 516 eq exch 520 eq or
			{
				/fhnumcolors 3 def
				/currentscreen {60 0 {pop pop 1}}bdf
				/calcgraysteps {maxsteps} bdf
			}if
		}if
	}if
}if

% utility routine: given a spot color index,
% return TRUE if we should print on current sep.
% goodsep: colorindex -- bool
/goodsep {
	spots exch get 4 get dup sepname eq exch (_vc_Registration) eq or
}bdf

%-----------------------------------------------------------------------
% variables
%-----------------------------------------------------------------------

/bottom -0 def			% bottom of rectangle
/delta -0 def			% delta value (radius, y coord, ...)
/frac -0 def			% current fractional value
/height -0 def			% height of rect
/left -0 def			% left side of rect
/numsteps -0 def		% # of steps for grad fills
/numsteps1 -0 def		% # of steps - 1 for grad fills
/radius -0 def			% current radius
/right -0 def			% right side of rect
/top -0 def				% top of rect
/width -0 def			% width of rect
/xt -0 def				% temp x coord
/yt -0 def				% temp y coord
/df currentflat def		% default flatness
/tempstr 1 string def	% a one char string
/clipflatness currentflat def	% default flatness for clipping paths (used to be 3)
/inverted?				% for eps, this tells us if we are printing inverted
	0 currenttransfer exec .5 ge def
/tc1 [0 0 0 1] def		% temp color 1
/tc2 [0 0 0 1] def		% temp color 2

% store t/l/b/r corners  of rect into variables
% left bottom right top --
/storerect{/top xdf /right xdf /bottom xdf /left xdf 
			/width right left sub def /height top bottom sub def}bdf

%-----------------------------------------------------------------------
% functions
%-----------------------------------------------------------------------

% Concatenate two procedures
% if either src proc is a packed array, make the dest one a packed array too;
% this is necessary since some Level 2 printers have a bug that makes
% colorimage barf if some of its proc parms are packed and some are not.
% proc1 proc2 -- result
/concatprocs{
	systemdict /packedarray known 
	{dup type /packedarraytype eq 2 index type /packedarraytype eq or}{false}ifelse
	{	% packedarray expects the contents on stack, unlike array
		/proc2 exch cvlit def	/proc1 exch cvlit def
		proc1 aload pop proc2 aload pop
		proc1 length proc2 length add packedarray cvx
	}
	{	% unpacked array
		/proc2 exch cvlit def	/proc1 exch cvlit def
		/newproc proc1 length proc2 length add array def
		newproc 0 proc1 putinterval newproc proc1 length proc2 putinterval
		newproc cvx
	}ifelse
}bdf

% setflat - treat 0 as restoration of default flatness
% flatness --
/i{dup 0 eq
	{pop df dup}	% reset default flat & default clipflat (used to be pop df dup 3 mul)
	{dup} ifelse 
	/clipflatness xdf setflat
}bdf

% fix setrgbcolor for transfer fcn
version cvr 38.0 le
{/setrgbcolor{
currenttransfer exec 3 1 roll
currenttransfer exec 3 1 roll
currenttransfer exec 3 1 roll
setrgbcolor}bdf}if

% vm save
% vms --
/vms {/vmsv save def} bdf

% vm restore
% vmr --
/vmr {vmsv restore} bdf

% vm restore save
% vmrs --
/vmrs{vmsv restore /vmsv save def}bdf

% now we also provide a routine to switch between eoclip/eofill and normal
% modes. passing true means go to eomode, passing false means go to winding-number mode.
% bool eomode --
/eomode{ 
	{/filler /eofill load def /clipper /eoclip load def}
	{/filler /fill load def /clipper /clip load def}
	ifelse
}bdf

% -------------------------------------------------------
% helper functions for grad fills
% -------------------------------------------------------

/normtaper{}bdf
/logtaper{9 mul 1 add log}bdf

% lfxform: helper function for linear fills.
% note that 'bbox' is the bbox of the path as transformed
% by angle. yes, we could calculate that here, but
% it would be slow, and also give wrong results for split paths.
% lfxform: bbox(lbrt) angle center(xy) --
/lfxform {
	/yt xdf /xt xdf
	xt yt translate						% to center of natural figure
	rotate								% by the correct angle
	storerect							% save the rect
	left xt sub bottom yt sub translate
	% note the trick here: if a sinister user makes a graduated fill
	% in an element with a bounding box of zero area (top == bottom
	% or left == right) then the scale would be zero, causing
	% an ugly error. to avoid this degenerate case, we just
	% make sure that it never quite gets to 0.
	right left sub 0.00001 max top bottom sub 0.00001 max scale	% scale to size of rotated bbox
}bdf

% these definitions are commented out because we now generate
% the strings in C and send em down, but we might want to
% use these again someday...

% some buffers for the lf routines.
%/lfbuf1 256 string def
%/lfbuf2 256 string def
%/lfbuf3 256 string def
%/lfbuf4 256 string def

% blstr: nice routine to produce a buffer with "continuous"
% tinting between two components. the string must be
% 256 chars in size. "taperfcn" must be defined to be
% some gradation function.
% blstr: cmp1 cmp2 str --
%/blstr{
%	/thestr xdf
%	/yt xdf
%	/xt xdf
%	0 1 255 {
%		thestr exch					% stack: str i
%		dup 255.0 div taperfcn 		% stack: str i frac
%		% ok, now calculate cmp = (t1 + (t2 - t1) * frac)
%		yt xt sub mul xt add		% stack: str i comp(fractional)
%		255.0 mul cvi				% stack: str i comp(byte)
%		put
%	}for
%}bdf

%-----------------------------------------------------------------------
% Text & font stuff
%-----------------------------------------------------------------------

% Copy dictionary
/CD{/NF exch def{exch dup/FID ne 1 index/UniqueID ne and{exch NF 3 1 roll put}
	{pop pop}ifelse}forall NF}bdf

% Make name
/MN{1 index length/Len exch def
	dup length Len add string dup 
	Len 4 -1 roll putinterval dup 0 4 -1 roll putinterval}bdf

% Recode: (name) -- 
% side effect define a new re-encoded font
/RC{4 -1 roll /ourvec xdf 256 string cvs(|______)anchorsearch
	{1 index MN cvn/NewN exch def cvn
	findfont dup maxlength dict CD dup/FontName NewN put dup
	/Encoding ourvec put NewN exch definefont pop}{pop}ifelse}bdf

% Re-encode font: (name) --
/RF{dup FontDirectory exch known{pop 3 -1 roll pop}{RC}ifelse}bdf

% Find font - looks under name given, or under |______name
% (fontname) -- fontobject
%/FF{dup FontDirectory exch known{findfont}{256 string cvs(|______)exch MN findfont}ifelse}bdf
/FF{dup 256 string cvs(|______)exch MN cvn dup FontDirectory exch known
	{exch pop findfont 3 -1 roll pop}
	{pop dup findfont dup maxlength dict CD dup dup
	/Encoding exch /Encoding get 256 array copy 7 -1 roll 
	{3 -1 roll dup 4 -2 roll put}forall put definefont}
	ifelse}bdf

%-----------------------------------------------------------------------
% Flattening routines.
%-----------------------------------------------------------------------

% fps: flatten path subroutine
% fps: proc maxflat desiredflat --
/fps{
	currentflat 		% proc maxflat desiredflat currentflat
	exch 				% proc maxflat currentflat desiredflat
	dup 0 le{pop 1}if	% proc maxflat currentflat desiredflat
	{
		dup setflat 3 index stopped
		{1.3 mul dup 3 index gt{pop setflat pop pop stop}if}	% didn't work
		{exit}			% everything worked OK
		ifelse
	}loop 
	pop setflat pop pop
}bdf

% fp: flatten path
% fp: proc --
/fp{100 currentflat fps}bdf

% also define these guys since they are used elsewhere
% used to be 'fclip' and 'feoclip', but now we use ugly Illustrator convention
/clipper{clip}bdf		% default value is winding number
/W{/clipper load 100 clipflatness fps}bdf


#### doc prolog part that is output only when printing directly to printer

%-----------------------------------------------------------------------
% only output this resource if printing from FreeHand directly (not EPS)
%-----------------------------------------------------------------------

%. Error handling code - don't do this if printing to hi res imagesetter
printerRes 1000 lt
{	
	errordict
	dup /shownerr false put
	/handleerror
	{	
		$error begin 
		/prt{dup type /stringtype ne{=string cvs}if show}def
		newerror
		{
			/newerror false store 
			grestoreall initgraphics
			errordict /shownerr get not
			{
				errordict /shownerr true put
				30 110 moveto 
				/Helvetica findfont 14 scalefont setfont 
				(POSTSCRIPT ERROR: ) prt errorname prt (    ) prt
				(OFFENDING COMMAND: ) prt /command load prt
%				(ioerror) errorname ne{systemdict /showpage get exec}if
			} if 	% if we haven't already printed an error
		}if 
		end
	}
	put
}if
%.

%-----------------------------------------------------------------------
% overlap marks, alignment marks, cut marks
%-----------------------------------------------------------------------

% overlap marks -- current position is center of rectangle
/overlapmark{-4 xs div 0 rlineto 4 xs div 2 div -7 ys div 2 div rmoveto
0 7 ys div rlineto 4 xs div 0 rlineto 0 -7 ys div rlineto -4 xs div 0 rlineto
.2 xs div setlinewidth stroke}bdf

% subroutine for /am -- stroke a relative line
% args:  rmovex rmovey rlinex rliney width 
/amsub{gsave setlinewidth 4 2 roll rmoveto rlineto stroke grestore}bdf

% alignment marks -- center of circle is on stack (xy)
/am{
	newpath 
	moveto					% center of circle
	0 setseparationgray
% draw the circles
	gsave			
	currentpoint 5 xs div 0 360 arc 		% make circle of radius 5, adjusted by scale
	.3 xs div setlinewidth 
	stroke 
	grestore 
	gsave
	currentpoint 3 xs div 0 360 arc 		% make circle of radius 3, adjusted by scale
	fill
	grestore
% draw the outer (black) tics
	3 xs div 0 5 xs div 0 .3 ys div amsub	% right	
	-3 xs div 0 -5 xs div 0 .3 ys div amsub	% left	
	0 3 ys div 0 5 ys div .3 xs div amsub	% top	
	0 -3 ys div 0 -5 ys div .3 xs div amsub	% bottom	
% draw the inner (white) tics
	1 setseparationgray
	-3 xs div 0 6 xs div 0 .3 ys div amsub	% horiz
	0 -3 ys div 0 6 ys div .3 xs div amsub	% vert
}bdf

% util routine for fhcb: 
% draw a box with lower left at xt, yt, then add 'delta' to xt
% box is filled with current color, stroked with black.
% if 'str' is not empty, draw it centered in the box (in black)
% fhcbox: delta str fhcbox --
/fhcbox {
	xt yt moveto
	13.5 xs div 0 rlineto
	0 13.5 ys div rlineto
	-13.5 xs div 0 rlineto
	0 -13.5 ys div rlineto
	gsave fill grestore
	0 setseparationgray stroke	% used to be 0.5 gray
	dup length 0 ne {
		0 setseparationgray
		dup stringwidth pop neg 13.5 xs div add 2 div xt add yt 5 ys div add moveto show
	}
	{pop} ifelse
	xs div xt add /xt xdf
}bdf

% color bars
% args: xpos ypos fhcb --
/fhcb {
	0.25 xs div 0.25 ys div add 2 div setlinewidth
	2 copy		% save the loc junk
	% draw the gray bars
	% each bar is 13.5 pts square.
	% the values below take us 12 pts away from the current pt
	6.75 ys div sub /yt xdf
	25.5 xs div sub /xt xdf
	% xt, yt are lower left corner of the box
	0 1 10 { % avoid cumulative errors
		10 div setseparationgray
		-13.5 () fhcbox
	}for
	% draw the cmyk bars
	% each bar is 13.5 pts square.
	% the values below take us 12 pts away from the current pt
	6.75 ys div sub /yt xdf
	12 xs div add /xt xdf
	% xt, yt are lower left corner of the box
	/Helvetica findfont 5 ys div scalefont setfont
	1 0 0 0 setcmykcolor 13.5 (C) fhcbox
	0 1 0 0 setcmykcolor 13.5 (M) fhcbox
	0 0 1 0 setcmykcolor 13.5 (Y) fhcbox
	1 1 0 0 setcmykcolor 13.5 (CM) fhcbox
	0 1 1 0 setcmykcolor 13.5 (MY) fhcbox
	1 0 1 0 setcmykcolor 13.5 (CY) fhcbox
	1 1 1 0 setcmykcolor 13.5 (CMY) fhcbox
	0 0 0 1 setcmykcolor 13.5 (K) fhcbox
}def	% NOT bdf -- might bind to setcmykcolor in systemdict!

% cut marks -- current position is lower left of image area
/mybleed{bleed 0 eq{wdist 10 sub xs div}{bleed}ifelse}bdf
/cm{mybleed neg 0 rmoveto -9 xs div 0 rlineto
9 xs div mybleed add mybleed neg rmoveto 0 -9 ys div rlineto
.3 xs div setlinewidth 0 setseparationgray stroke}bdf


################### document prolog output only on the Mac

% ---------- note -------------
% this next section of code is actually only used on the Mac.

% font dict for Brainless Dolt's clever tricks
% Many routines called by Apple's 'md' commented out so
% they don't screw up our carefully established state
userdict begin /BDFontDict 20 dict def end
BDFontDict begin
% does 'restore'
/bu{}def
% does 'save'
/bn{}def
% does 'setgray'
/setTxMode{av 70 ge{pop}if pop}def
% calls extraneous routines
/gm{m}def
% don't make a mark on page
/show{pop}def
% does 'setgray'
/gr{pop}def
% we'd actually better do this 'rf' for Zapf-Dingbats
%/rf{cleartomark pop}def
% don't need this - calls 'sfd' to do a lot of weird stuff
/fnt{pop pop pop}def
% don't need this - stores into 'sa'
/fs{pop}def
% don't need this - creates new def 'ps'
/fz{pop}def
% don't make a mark on page
/lin{pop pop}def
end

% Macintosh encoding vector
/MacVec 256 array def 

% start with Helvetica's encoding
MacVec 0 /Helvetica findfont

% copy first 128 chars, replacing the few that are different
/Encoding get 0 128 getinterval putinterval
MacVec 127 /DEL put MacVec 16#27 /quotesingle put MacVec 16#60 /grave put
/NUL/SOH/STX/ETX/EOT/ENQ/ACK/BEL/BS/HT/LF/VT/FF/CR/SO/SI
/DLE/DC1/DC2/DC3/DC4/NAK/SYN/ETB/CAN/EM/SUB/ESC/FS/GS/RS/US
MacVec 0 32 getinterval astore pop

% Now list names for high 128 chars that are different
/Adieresis/Aring/Ccedilla/Eacute/Ntilde/Odieresis/Udieresis/aacute
/agrave/acircumflex/adieresis/atilde/aring/ccedilla/eacute/egrave
/ecircumflex/edieresis/iacute/igrave/icircumflex/idieresis/ntilde/oacute
/ograve/ocircumflex/odieresis/otilde/uacute/ugrave/ucircumflex/udieresis
/dagger/degree/cent/sterling/section/bullet/paragraph/germandbls
/registered/copyright/trademark/acute/dieresis/notequal/AE/Oslash
/infinity/plusminus/lessequal/greaterequal/yen/mu/partialdiff/summation
/product/pi/integral/ordfeminine/ordmasculine/Omega/ae/oslash 
/questiondown/exclamdown/logicalnot/radical/florin/approxequal/Delta/guillemotleft
/guillemotright/ellipsis/nbspace/Agrave/Atilde/Otilde/OE/oe
/endash/emdash/quotedblleft/quotedblright/quoteleft/quoteright/divide/lozenge
/ydieresis/Ydieresis/fraction/currency/guilsinglleft/guilsinglright/fi/fl
/daggerdbl/periodcentered/quotesinglbase/quotedblbase
/perthousand/Acircumflex/Ecircumflex/Aacute
/Edieresis/Egrave/Iacute/Icircumflex/Idieresis/Igrave/Oacute/Ocircumflex
/apple/Ograve/Uacute/Ucircumflex/Ugrave/dotlessi/circumflex/tilde
/macron/breve/dotaccent/ring/cedilla/hungarumlaut/ogonek/caron
MacVec 128 128 getinterval astore pop

% ----------------- end of Mac special section -------------

################### end of document prolog

end		%. AltsysDict

%%EndProcSet

################### just the one comment

%%EndProlog

##################

%%BeginSetup

##################

%%EndSetup

################### common code at start of a color sep
%-----------------------------------------------------------------------
% common code for all separations - output before separation-specific code
%-----------------------------------------------------------------------
% First define the things which are a part of the Adobe Color Separation
% Conventions.
%------------------------------------------------------------------------
% output both these for silly apps that dont recognize BeginSeparation
%%BeginSeparation: ^Q
%%PlateColor: ^Q
userdict begin /AltsysSepDict 60 dict def end

AltsysSepDict begin
/sepname (^Q) def
AltsysDict begin
% leave those two on the stack thru this page.
% now push the SepDict on the stack again (temporarily)
% to make a bunch of defs into it.
AltsysSepDict begin

/_image/image load def
/colorimage defed {/_colorimage /colorimage load def} if
/_imagemask/imagemask load def
/_setgray/setgray load def

########################################################################

%-----------------------------------------------------------------------
% process cyan separation
%-----------------------------------------------------------------------

/setgray{pop 1 _setgray}bdf

/setcmykcolor{
	overprintcmyk
	pop pop pop 1 exch sub _setgray
}bdf

% colorimage: width height bits matrix proc0 proc1 proc2 proc3 true 4 colorimage --
/colorimage{
	pop pop
	[
		5 -1 roll	% stack: proc1 proc2 proc3 [ proc0
		/exec cvx	% stack: proc1 proc2 proc3 [ proc0 exec 
		6 -1 roll
		/exec cvx 
		7 -1 roll
		/exec cvx 
		8 -1 roll
		/exec cvx	% stack: [ proc0 exec proc1 exec proc2 exec proc3 exec
		/pop cvx
		/pop cvx
		/pop cvx
	]
	cvx 
	{1.0 exch sub} bind currenttransfer concatprocs st
	_image
}bdf

% image: width height bits matrix proc0 image --
% note: this def works ONLY for L1 image, not L2 one-dict image.
/image{
	3 1 getprocessoverprint		% see if process black ink is overprinting
	{gsave nulldevice _image grestore}
	{inverted?{{pop 0}}{{pop 1}}ifelse st _image}
	ifelse
}bdf

% setcolortransfer: proc proc proc proc --
/setcolortransfer{pop pop pop st}bdf

% lfp: linear fill for a process color (cyan def)
% lfp: <g> <c> <m> <y> <k> c m y k c m y k taperfcn bbox(lbrt) angle center(xy) --
/lfp{
	gsave
	W n								% clip to the path
	lfxform							% set up transform correctly; eat center, bbox, angle
	12 {pop} repeat					% pop taperfcn, both cmyks, useless data
	/lfbuf1 xdf						% get cdata
	pop								% pop graydata
	{1.0 exch sub} bind currenttransfer concatprocs st
	1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
	{lfbuf1}
	_image
	grestore
}bdf

########################################################################

%-----------------------------------------------------------------------
% process magenta separation
%-----------------------------------------------------------------------

/setgray{pop 1 _setgray}bdf

/setcmykcolor{
	overprintcmyk
	pop pop 1 exch sub _setgray pop
}bdf

% colorimage: width height bits matrix proc0 proc1 proc2 proc3 true 4 colorimage --
/colorimage{
	pop pop
	[
		5 -1 roll	% stack: proc1 proc2 proc3 [ proc0
		/exec cvx	% stack: proc1 proc2 proc3 [ proc0 exec 
		6 -1 roll
		/exec cvx 
		7 -1 roll
		/exec cvx 
		8 -1 roll
		/exec cvx	% stack: [ proc0 exec proc1 exec proc2 exec proc3 exec
		/pop cvx
		/pop cvx
		/exch cvx
		/pop cvx
	]
	cvx 
	{1.0 exch sub} bind currenttransfer concatprocs st
	_image
}bdf

% image: width height bits matrix proc0 image --
% note: this def works ONLY for L1 image, not L2 one-dict image.
/image{
	3 1 getprocessoverprint		% see if process black ink is overprinting
	{gsave nulldevice _image grestore}
	{inverted?{{pop 0}}{{pop 1}}ifelse st _image}
	ifelse
}bdf

% setcolortransfer: proc proc proc proc --
/setcolortransfer{pop pop exch pop st}bdf

% lfp: linear fill for a process color (magenta def)
% lfp: <g> <c> <m> <y> <k> c m y k c m y k taperfcn bbox(lbrt) angle center(xy) --
/lfp{
	gsave
	W n								% clip to the path
	lfxform							% set up transform correctly; eat center, bbox, angle
	11 {pop} repeat					% pop taperfcn, both cmyks, ykdata
	/lfbuf1 xdf						% get mdata
	pop pop							% pop cdata, graydata
	{1.0 exch sub} bind currenttransfer concatprocs st
	1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
	{lfbuf1}
	_image
	grestore
}bdf

########################################################################

%-----------------------------------------------------------------------
% process yellow separation
%-----------------------------------------------------------------------

/setgray{pop 1 _setgray}bdf

/setcmykcolor{
	overprintcmyk
	pop 1 exch sub _setgray pop pop
}bdf

% colorimage: width height bits matrix proc0 proc1 proc2 proc3 true 4 colorimage --
/colorimage{
	pop pop
	[
		5 -1 roll	% stack: proc1 proc2 proc3 [ proc0
		/exec cvx	% stack: proc1 proc2 proc3 [ proc0 exec 
		6 -1 roll
		/exec cvx 
		7 -1 roll
		/exec cvx 
		8 -1 roll
		/exec cvx	% stack: [ proc0 exec proc1 exec proc2 exec proc3 exec
		/pop cvx
		/exch cvx
		/pop cvx
		/exch cvx
		/pop cvx
	]
	cvx 
	{1.0 exch sub} bind currenttransfer concatprocs st
	_image
}bdf

% image: width height bits matrix proc0 image --
% note: this def works ONLY for L1 image, not L2 one-dict image.
/image{
	3 1 getprocessoverprint		% see if process black ink is overprinting
	{gsave nulldevice _image grestore}
	{inverted?{{pop 0}}{{pop 1}}ifelse st _image}
	ifelse
}bdf

% setcolortransfer: proc proc proc proc --
/setcolortransfer{pop 3 1 roll pop pop st}bdf

% lfp: linear fill for a process color (yellow def)
% lfp: <g> <c> <m> <y> <k> c m y k c m y k taperfcn bbox(lbrt) angle center(xy) --
/lfp{
	gsave
	W n								% clip to the path
	lfxform							% set up transform correctly; eat center, bbox, angle
	10 {pop} repeat					% pop taperfcn, both cmyks, useless data
	/lfbuf1 xdf						% get ydata
	pop pop pop						% pop mdata, cdata, graydata
	{1.0 exch sub} bind currenttransfer concatprocs st
	1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
	{lfbuf1}
	_image
	grestore
}bdf

########################################################################

%-----------------------------------------------------------------------
% process black separation
%-----------------------------------------------------------------------

/setgray{_setgray}bdf

/setcmykcolor{
	overprintcmyk
	1 exch sub _setgray pop pop pop
}bdf

% colorimage: width height bits matrix proc0 proc1 proc2 proc3 true 4 colorimage --
/colorimage{
	pop pop
	[
		5 -1 roll	% stack: proc1 proc2 proc3 [ proc0
		/exec cvx	% stack: proc1 proc2 proc3 [ proc0 exec 
		6 -1 roll
		/exec cvx 
		7 -1 roll
		/exec cvx 
		8 -1 roll
		/exec cvx	% stack: [ proc0 exec proc1 exec proc2 exec proc3 exec
		/exch cvx
		/pop cvx
		/exch cvx
		/pop cvx
		/exch cvx
		/pop cvx
	]
	cvx 
	{1.0 exch sub} bind currenttransfer concatprocs st
	_image
}bdf

% image: width height bits matrix proc0 image --
% note: this def works ONLY for L1 image, not L2 one-dict image.
/image{_image}bdf

% setcolortransfer: proc proc proc proc --
/setcolortransfer{4 1 roll pop pop pop st}bdf

% lfp: linear fill for a process color (black def)
% lfp: <g> <c> <m> <y> <k> c m y k c m y k taperfcn bbox(lbrt) angle center(xy) --
/lfp{
	gsave
	W n								% clip to the path
	lfxform							% set up transform correctly; eat center, bbox, angle
	9 {pop} repeat					% pop taperfcn, both cmyks, useless data
	/lfbuf1 xdf						% get kdata
	4 {pop} repeat					% pop other data
	{1.0 exch sub} bind currenttransfer concatprocs st
	1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
	{lfbuf1}
	_image
	grestore
}bdf

########################################################################

%-----------------------------------------------------------------------
% additional stuff for all process seps (mainly redefs for spot operators)
%-----------------------------------------------------------------------

% currently nothing is here... we used to redefine lfs, rfs, and 
% customcolorimage, but addition of the Registration color made it
% simpler to just put them in the generic sep header.

%. unused

% note: currently no redef of 'rfp' for process seps cause I don't
% know of a reasonable way to optimize it any further for that case.

########################################################################

%-----------------------------------------------------------------------
% spot color separation
%-----------------------------------------------------------------------

/setgray{pop 1 _setgray}bdf

/setcmykcolor{
	overprintcmyk
	pop pop pop pop 1 _setgray
}bdf

% colorimage: width height bits matrix proc0 proc1 proc2 proc3 true 4 colorimage --
/colorimage{
	pop pop
	[
		5 -1 roll	% stack: proc1 proc2 proc3 [ proc0
		/exec cvx	% stack: proc1 proc2 proc3 [ proc0 exec 
		6 -1 roll
		/exec cvx 
		7 -1 roll
		/exec cvx 
		8 -1 roll
		/exec cvx	% stack: [ proc0 exec proc1 exec proc2 exec proc3 exec
		/pop cvx
		/pop cvx
		/pop cvx
	]
	cvx 
	inverted?{{pop 0}}{{pop 1}}ifelse st _image
}bdf

% image: width height bits matrix proc0 image --
% note: this def works ONLY for L1 image, not L2 one-dict image.
/image{
	3 1 getprocessoverprint		% see if process black ink is overprinting
	{gsave nulldevice _image grestore}
	{inverted?{{pop 0}}{{pop 1}}ifelse st _image}
	ifelse
}bdf

% setcolortransfer: proc proc proc proc --
/setcolortransfer{4 1 roll pop pop pop st}bdf

% lfp: linear fill for a process color (spot def)
% lfp: <g> <c> <m> <y> <k> c m y k c m y k taperfcn bbox(lbrt) angle center(xy) --
/lfp{
	% shouldn't need to handle overprinting here
	gsave 1 setseparationgray {filler} fp grestore
	21 {pop} repeat
}bdf

% Radial fill - process color
% cx cy radius c m y k c m y k --
/rfp{
	% shouldn't need to handle overprinting here
	gsave 1 setseparationgray {filler} fp grestore
	11 {pop} repeat
}bdf

#################################################################

%-----------------------------------------------------------------------
% common code for all separations - output after separation-specific code
%-----------------------------------------------------------------------

%-----------------------------------------------------------------------
% Define some helper functions for sep printing
%-----------------------------------------------------------------------

/ucrk .5 def		% black undercolor removal starts here
/ucrm .31 def		% percent of magenta undercolor removal
/ucry .48 def		% percent of yellow undercolor removal
/boostk 1.25 def	% compensation for additive failure (leq 1/ucrk)

/cvt1{1 exch sub 3 1 roll}bdf
/cvt2{0 max 3 1 roll}bdf

% set rgb color
% r g b --
/setrgbcolor{
	cvt1 cvt1 cvt1						% c m y
	3 copy min min						% c m y min
	ucrk sub 0 max						% c m y k
	4 1 roll							% k c m y
	3 {3 index sub 3 1 roll} repeat		% k c-k m-k y-k
	1 index ucry mul sub cvt2			% k y' c m
	1 index ucrm mul sub cvt2			% k m' y' c
	3 1 roll							% k c m' y'
	4 -1 roll boostk mul				% c m' y' k'
	setcmykcolor
}bdf

/_sethsbcolor/sethsbcolor load def
/sethsbcolor{_sethsbcolor currentrgbcolor setrgbcolor}bdf
/setcmybcolor{setcmykcolor}bdf

%-----------------------------------------------------------------------
% code to support spot color operators
%-----------------------------------------------------------------------

% define setspotcolor operator (sep def): tint colorindex --
/setspotcolor{	
	spots exch get 
	dup 5 get setinkoverprint	% set ink overprint junk
	4 get dup sepname eq exch (_vc_Registration) eq or			% correct sep?
	{1 exch sub _setgray}		% yep, set tint
	{pop 1 _setgray}			% nope, knock it out
	ifelse
}bdf

%-----------------------------------------------------------------------
% code to support Adobe's Color EPS format
%-----------------------------------------------------------------------
% setcmykcoloroverprint: c m y k setcmykcoloroverprint --
/setcmykcoloroverprint{pop pop pop pop}bdf

% findcmykcustomcolor: c m y k (colorname) findcmykcustomcolor -- [c m y k (colorname)]
/findcmykcustomcolor{5 packedarray}bdf

% setcustomcolor: [c m y k (color)] tint setcustomcolor --
% note: this doesn't handle Registration color because
% it is assumed that setspotcolor intercepts those cases first.
/setcustomcolor{
	exch 4 get sepname eq
	{1 exch sub _setgray}		% set tint
	{pop 1 _setgray}			% knock it out
	ifelse
}bdf

% setseparationgray: gray setseparationgray --
/setseparationgray{_setgray}bdf

% inkoverprint: -- boolean
/inkoverprint false def

% currentoverprint: -- currentoverprint boolean
/currentoverprint false def

% setoverprint: boolean setoverprint --
/setoverprint{inkoverprint{pop}{/currentoverprint sepdef}ifelse}bdf

% setinkoverprint: bool --
% don't set currentoverprint unless this ink overprints
% else we zap currentoverprint every time we set a spot color
/setinkoverprint{dup /inkoverprint sepdef /currentoverprint sepdef}bdf

% onlyk: c m y k -- c m y k boolean
/onlyk{4 copy 0 ne exch 0 eq and exch 0 eq and exch 0 eq and}bdf

% onlyc: c m y k boolean -- c m y k boolean boolean
/onlyc{5 copy pop 0 eq exch 0 eq and exch 0 eq and exch 0 ne and}bdf

% onlym: c m y k boolean boolean -- c m y k boolean boolean boolean
/onlym{6 copy pop pop 0 eq exch 0 eq and exch 0 ne and exch 0 eq and}bdf

% onlyy: c m y k boolean boolean  boolean -- c m y k boolean boolean boolean boolean
/onlyy{7 copy pop pop pop 0 eq exch 0 ne and exch 0 eq and exch 0 eq and}bdf

% getprocessoverprint index colorval -- boolean
/getprocessoverprint
	{0 ne{spots exch get 5 get}{pop false}ifelse}bdf
	
% getcustomoverprint: [c m y k (color)] -- boolean
% this is not really part of Adobe spec, but I needed it
% to do customcolorimage correctly, so here it is.
/getcustomoverprint{
	4 get		% extract the name
	false		% default return val
	% gnarly -- have to search through spots manually!
	% this is slow, so avoid using this!
	spots
	{							% stack: name bool [c m y k (name) bool]
		dup 4 get 3 index eq	% stack: name bool [c m y k (name) bool] samename
		{5 get exch pop}		% found it, get overprint value
		{pop}					% nope, continue
		ifelse
	} forall
	% stack: name bool
	exch pop
}bdf

% overprintcmyk: c m y k -- c m y k
% if the ink is pure (3 of the c, m, y, and k values are 0), 
% overprint based on the overprint flag in the spots array.
% 'which' is the index of the ink we are interested in.
/overprintcmyk{
	onlyk onlyc onlym onlyy or or or
	{4 copy 3 -1 0{exch getprocessoverprint 4 1 roll}for or or or}
	{false}
	ifelse
	setinkoverprint
}bdf

% separationimage: width height bits matrix proc separationimage --
/separationimage{_image}bdf

%-----------------------------------------------------------------------
% code to support overprinting
%-----------------------------------------------------------------------
% redefine all painting operators to support overprinting

% paintok returns true if painting operations are OK
% We want to paint if we are printing on the right separation
% (to paint it), or if we are printing on the wrong separation
% but not overprinting (to knock it out). We don't want to paint
% if we are OVERprinting on the wrong separation.
/paintok{currentoverprint not currentgray 1 ne or}bdf
	
/stroke{paintok{stroke}{newpath}ifelse}bdf
/fill{paintok{fill}{newpath}ifelse}bdf
/eofill{paintok{eofill}{newpath}ifelse}bdf
% note: these only work for the one-rect case
/rectstroke{paintok{rectstroke}{pop pop pop pop}ifelse}bdf
/rectfill{paintok{rectfill}{pop pop pop pop}ifelse}bdf

/show{paintok{show}{pop}ifelse}bdf
/ashow{paintok{ashow}{pop pop pop}ifelse}bdf
/widthshow{paintok{widthshow}{pop pop pop pop}ifelse}bdf
/awidthshow{paintok{awidthshow}{pop pop pop pop pop pop}ifelse}bdf
/kshow{paintok{kshow}{pop pop}ifelse}bdf

/imagemask{paintok
	{currentgray 1 ne
		{_imagemask}				% OK to image
		{inverted?{{pop 0}}{{pop 1}}ifelse st _imagemask}
		ifelse}
	{gsave nulldevice _imagemask grestore}
	ifelse}bdf

% customcolorimage: width height bits matrix proc [c m y k (colorname)] customcolorimage --
/customcolorimage{
% only want to pass on to image if this is the *right* spot color (or registration)
	dup 4 get dup sepname eq exch (_vc_Registration) eq or
	{pop _image}
	{
		% this is horrible... have to see if the given spot color is overprinting.
		getcustomoverprint
		{gsave nulldevice _image grestore}
		{inverted?{{pop 0}}{{pop 1}}ifelse st _image}
		ifelse
	}
	ifelse
}bdf


% lfs: linear fill for a spot color
% we can optimize this for seps by avoiding customcolorimage.
% however, the def is essentially the same on all seps.
% lfs: <imagedata> spotnum starttint endtint taperfcn bbox(lbrt) angle center(xy) --
/lfs{
	% make sure it's the correct spot color.
	10 index goodsep
	{
		gsave
		W n								% clip to the path
		lfxform							% set up transform correctly; eat center, bbox, angle
		pop pop pop						% pop taper fcn, start & end tint
		/xt xdf							% save off the color index for below
		/lfbuf1 xdf						% define the image buf
		1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
		{lfbuf1}						% the data src
		_image
		grestore
	}
	{
		% if ink overprints, do nothing; if ink knocks out, fill with white
		10 index 1 getprocessoverprint	% see if ink is overprinting
		not {gsave 1 setseparationgray {filler} fp grestore} if
		12 {pop} repeat
	}
	ifelse
}bdf

% Radial fill - spot color
% cx cy radius spotnum starttint endtint --
/rfs{
	% make sure it's the correct spot color.
	2 index goodsep
	{_rfs}
	{
		% if ink overprints, do nothing; if ink knocks out, fill with white
		2 index 1 getprocessoverprint	% see if ink is overprinting
		not {gsave 1 setseparationgray {filler} fp grestore} if
		6 {pop} repeat
	}
	ifelse
}bdf


% --------------------------------------
% code for autospreads
% --------------------------------------

% autospread: autospread the current path. 
% assumes the proper color is already set.
% also assumes spread amount is in /fhspreadsize in AltsysSepDict.
% -- will this need special attention for dashed lines?
% -- if autospreading a stroke, set endcap to square if endcap is butt?
% -- adjust spread size down if spreadsize > linewidth?
% -- assumption: these calls will not be output if spreadsize <= 0.
/fas{
	currentoverprint not		% only spread if NOT overprinting this fill/line
	{
		gsave 
		fhspreadsize setlinewidth [] 0 setdash
		currentoverprint			% save cur overprint status on stack
		true setoverprint stroke setoverprint 
		grestore
	}
	if
}bdf

/sas{
	currentoverprint not		% only spread if NOT overprinting this fill/line
	{
		gsave 
		currentlinewidth fhspreadsize add setlinewidth
		currentoverprint			% save cur overprint status on stack
		true setoverprint stroke setoverprint 
		grestore
	}
	if
}bdf

% fhsetspreadsize: set the size for auto-spreading.
% defines in 'fhspreadsize' in AltsysSepDict.
% fhsetspreadsize: num --
/fhsetspreadsize{/fhspreadsize sepdef}ndf

end		%.AltsysSepDict

########### comp-specific header, output only for comp (or EPS)

AltsysDict begin	% Begin Composite Proof

########### code output at start of printing, after outputting sep- or comp-specific PS

%-----------------------------------------------------------------------
% composite header - this contains all defs for composite printing case
%					or for EPS generation
%-----------------------------------------------------------------------
% First define the things which are a part of the Adobe Color Separation
% Conventions.  Note:  ALL of these are conditionally defined (ndf).
%------------------------------------------------------------------------
% onlyk: c m y k -- c m y k boolean
/onlyk{false}ndf

% convert one component of a cmyk color to its rgb equivalent
% c m y 1-k -- m y r 1-k  or  m y r 1-k -- y r g 1-k  or  y r g 1-k -- r g b 1-k
/ccmyk{dup 5 -1 roll sub 0 max exch}ndf

% convert a cmyk to a gray with the right luminance.
% c m y k -- gray
/cmyk2gray{
	4 -1 roll 0.3 mul 4 -1 roll 0.59 mul 4 -1 roll 0.11 mul
	add add add 1 min neg 1 add
}bdf

% setcmykcolor: c m y k setcmykcolor --
/setcmykcolor{1 exch sub ccmyk ccmyk ccmyk pop setrgbcolor}ndf

% setcmykcoloroverprint: c m y k setcmykcoloroverprint --
/setcmykcoloroverprint{4{dup -1 eq{pop 0}if 4 1 roll}repeat setcmykcolor}ndf

% findcmykcustomcolor: c m y k (colorname) findcmykcustomcolor -- [c m y k (colorname)]
/findcmykcustomcolor{5 packedarray}ndf

% setcustomcolor: [c m y k (color)] tint setcustomcolor --
/setcustomcolor{exch aload pop pop 4{4 index mul 4 1 roll}repeat setcmykcolor pop}ndf

% setseparationgray: gray setseparationgray --
% we used to define it using setcmykcolor, but that makes composites look like mud
% (try it on the color bars and see what I mean). Instead, we'll
% ndf it as plain setgray, on the assumption that if we are enclosed
% in a separation header, the separator will define it correctly anyway,
% and the def used here doesn't matter...
/setseparationgray{setgray}ndf

% setoverprint: boolean setoverprint --
/setoverprint{pop}ndf		% not used for composite printing

% currentoverprint: -- currentoverprint boolean
/currentoverprint false ndf

%cmykbufs2gray: -- cyanbuf magentabuf yellowbuf blackbuf -- graybuf
/cmykbufs2gray{
	0 1 2 index length 1 sub
	{	
		4 index 1 index get	0.3 mul		% cyan
		4 index 2 index get	0.59 mul	% magenta		
		4 index 3 index get	0.11 mul	% yellow
		4 index 4 index get				% black
		add add add cvi 255 min
		255 exch sub
		2 index 3 1 roll put
	}for
	4 1 roll pop pop pop
}bdf

% colorimage: width height bits matrix proc0 proc1 proc2 proc3 true 4 colorimage --
/colorimage{
	pop pop
	[
		5 -1 roll/exec cvx 
		6 -1 roll/exec cvx 
		7 -1 roll/exec cvx 
		8 -1 roll/exec cvx
		/cmykbufs2gray cvx
	]cvx 
	image
}
%. version 47.1 on Linotronic of Postscript defines colorimage incorrectly (rgb model only)
version cvr 47.1 le 
statusdict /product get (Lino) anchorsearch{pop pop true}{pop false}ifelse
and{userdict begin bdf end}{ndf}ifelse

% customcolorimage: width height bits matrix proc [c m y k (colorname)] customcolorimage --
% multiple defs for each case of fhnumcolors; separated to save vm

% 1-color case
fhnumcolors 1 ne {/yt save def} if
/customcolorimage{
	aload pop
	(_vc_Registration) eq 
	{
		pop pop pop pop separationimage
	}
	{
		/ik xdf /iy xdf /im xdf /ic xdf
		% convert the cmyk into a gray value. this 
		% formula is taken from the RedBookV2, p305:
		% gray = 1.0 - min(1.0, 0.3c + 0.59m + 0.11y + k)
		% note: sleazing it up by re-using xt as a temp var here...
		% I'm afraid to use ik (etc) for fear that we may redefine
		% image to use it somehow.
		ic im iy ik cmyk2gray /xt xdf
		currenttransfer
		{dup 1.0 exch sub xt mul add}concatprocs
		st		
		image
	}
	ifelse
}ndf
fhnumcolors 1 ne {yt restore} if

% 3-color case
fhnumcolors 3 ne {/yt save def} if
/customcolorimage{
	aload pop 
	aload pop
	(_vc_Registration) eq 
	{
		pop pop pop pop separationimage
	}
	{
		/ik xdf /iy xdf /im xdf /ic xdf
		% convert cmyk to rgb -- see RedBookV2p307
		1.0 dup ic ik add min sub	% red
		1.0 dup im ik add min sub	% green
		1.0 dup iy ik add min sub	% blue
		/ic xdf /iy xdf /im xdf
		currentcolortransfer
		4 1 roll	% ignore the gray proc -- not used in this case
		{dup 1.0 exch sub ic mul add}concatprocs 4 1 roll	% blue proc
		{dup 1.0 exch sub iy mul add}concatprocs 4 1 roll	% green proc
		{dup 1.0 exch sub im mul add}concatprocs 4 1 roll	% red proc
		setcolortransfer
		% assumption: if this def is being used, we are not printing
		% seps, so it's ok to use the 3-color colorimage. if
		% we are doing seps, the separator should have redefined
		% customcolorimage. If they haven't, well, we won't print
		% correctly, but then, we wouldn't have anyway, and this
		% seems to give much better results to real 3-color devices
		% (e.g., the Next Colorstation).
		{/dummy xdf dummy}concatprocs{dummy}{dummy}true 3 colorimage
	}
	ifelse
}ndf
fhnumcolors 3 ne {yt restore} if

% 4-color case
fhnumcolors 4 ne {/yt save def} if
/customcolorimage{
	aload pop
	(_vc_Registration) eq 
	{
		pop pop pop pop separationimage
	}
	{
		/ik xdf /iy xdf /im xdf /ic xdf
		currentcolortransfer
		{1.0 exch sub ik mul ik sub 1 add}concatprocs 4 1 roll
		{1.0 exch sub iy mul iy sub 1 add}concatprocs 4 1 roll
		{1.0 exch sub im mul im sub 1 add}concatprocs 4 1 roll
		{1.0 exch sub ic mul ic sub 1 add}concatprocs 4 1 roll
		setcolortransfer
		{/dummy xdf dummy}concatprocs{dummy}{dummy}{dummy}
		true 4 colorimage
	}
	ifelse
}ndf
fhnumcolors 4 ne {yt restore} if

% separationimage: width height bits matrix proc separationimage --
/separationimage{image}ndf

%------------------------------------------------------------------------
% Now define some things which are a part of our composite/EPS header
% which are not part of the Adobe Color Separation Conventions.
%------------------------------------------------------------------------

% newcmykcustomcolor: c m y k (colorname) overprintink newcmykcustomcolor -- [c m y k (colorname) overprintink]
/newcmykcustomcolor{6 packedarray}ndf

% inkoverprint: -- inkoverprint boolean
/inkoverprint false ndf

% setinkoverprint: bool --
/setinkoverprint{pop}ndf		% not used for composite

% setspotcolor (composite def): tint color# --
/setspotcolor {		% tint colorindex setspotcolor -
	spots exch get
	dup 4 get (_vc_Registration) eq
	{pop 1 exch sub setseparationgray}
	{0 5 getinterval exch setcustomcolor}
	ifelse
}ndf

% currentcolortransfer: currentcolortransfer -- proc proc proc proc
/currentcolortransfer{currenttransfer dup dup dup}ndf

% setcolortransfer: proc proc proc proc setcolortransfer --
/setcolortransfer{st pop pop pop}ndf

/fas{}ndf
/sas{}ndf

% fhsetspreadsize: set the size for auto-spreading.
% in composite mode, does nothing.
% fhsetspreadsize: num --
/fhsetspreadsize{pop}ndf

/filler{fill}bdf			% default value is winding-number

% fill the current path. contrary to Ill's spec, leave it intact after filling
% (so we can reuse these routines for non-Ill-compatible elements).
/F{gsave {filler}fp grestore}bdf
/f{closepath F}bdf

% stroke the current path. clobber it when done.
/S{gsave {stroke}fp grestore}bdf
/s{closepath S}bdf

% lfs: linear fill for a spot color (composite def)
% lfs: <imagedata> spotnum starttint endtint taperfcn bbox(lbrt) angle center(xy) --
/lfs{
	gsave
	W n								% clip to the path
	lfxform							% set up transform correctly; eat center, bbox, angle
	pop pop pop						% pop taper fcn, start & end tint
	/xt xdf							% save off the color index for below
	/lfbuf1 xdf						% define the image buf
	1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
	{lfbuf1}						% the data src
	[spots xt get aload pop pop]	% fake up a customcolor
	customcolorimage
	grestore
}ndf

% lfp: linear fill for a process color (composite def)
% lfp: <g> <c> <m> <y> <k> c m y k c m y k taperfcn bbox(lbrt) angle center(xy) --
/lfp{
	gsave
	W n								% clip to the path
	lfxform							% set up transform correctly; eat center, bbox, angle
	9 {pop} repeat					% pop taperfcn, both cmyks
	_rci							% we have a reasonable version of colorimage
	{
		/lfbuf4 xdf
		/lfbuf3 xdf
		/lfbuf2 xdf
		/lfbuf1 xdf
		pop
		1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
		{lfbuf1}{lfbuf2}{lfbuf3}{lfbuf4}
		true 4 colorimage
	}
	{		% we have no real colorimage, so just go straight to image.
		4 {pop} repeat
		/lfbuf1 xdf
		1 256 8 [1 0 0 -256 0 256]		% make our image defined top-to-bottom
		{lfbuf1}
		image
	}
	ifelse
	grestore
}ndf

% Radial fill - spot color
% cx cy radius spotnum starttint endtint --
/bcs [0 0] def	% blend color - spot
/_rfs {
	/tint2 xdf						% color 2
	/tint1 xdf						% color 1
	bcs exch 1 exch put				% go ahead and cram spot num into bcs
	/radius xdf						% radius
	/yt xdf							% center y
	/xt xdf							% center x
	tint1 tint2 sub abs				% delta
	calcgraysteps mul abs round		% find numsteps
	dup 0 eq {pop 1} if				% always at least 1 step
	1 sub /numsteps1 xdf
	currentflat mark				% -- currentflat mark
	currentflat clipflatness		% -- currentflat mark modcurflat modclipflat
	{
		{
			dup setflat				% set flatness to clipflatness or adjusted value
			W 						% clip
			0 1 numsteps1			% for loop parms
			{
				numsteps1 div /frac xdf
				bcs 0
				tint2 tint1 sub frac mul tint1 add
				put bcs vc
				1 index setflat		% set flatness to modified current flatness
				{		
					newpath mark xt yt radius 1 frac sub mul 0 360
					{arc fill}stopped
					{cleartomark exch 1.3 mul dup setflat exch 2 copy gt{stop}if}
					{cleartomark exit}ifelse
				}loop
			}for
		}
		gsave stopped grestore
		{exch pop 2 index exch 1.3 mul dup 100 gt{cleartomark setflat stop}if}
		{exit}ifelse
	}loop
	cleartomark setflat
% leave path active
}bdf

% Radial fill - process color
% cx cy radius c m y k c m y k --
/bc4 [0 0 0 0] def	% blend color - process
/_rfp {
	/k2 xdf /y2 xdf /m2 xdf /c2 xdf
	/k1 xdf /y1 xdf /m1 xdf /c1 xdf
	/radius xdf						% radius
	/yt xdf							% center y
	/xt xdf							% center x
	c1 c2 sub abs
	m1 m2 sub abs
	y1 y2 sub abs
	k1 k2 sub abs
	max max max						% find delta
	calcgraysteps mul abs round		% find numsteps
	dup 0 eq {pop 1} if				% always at least 1 step
	1 sub /numsteps1 xdf
	currentflat mark				% -- currentflat mark
	currentflat clipflatness		% -- currentflat mark modcurflat modclipflat
	{
		{
			dup setflat				% set flatness to clipflatness or adjusted value
			W 						% clip
			0 1 numsteps1			% for loop parms
			{
				numsteps1 div /frac xdf
				bc4 0 c2 c1 sub frac mul c1 add put
				bc4 1 m2 m1 sub frac mul m1 add put
				bc4 2 y2 y1 sub frac mul y1 add put
				bc4 3 k2 k1 sub frac mul k1 add put
				bc4 vc
				1 index setflat		% set flatness to modified current flatness
				{		
					newpath mark xt yt radius 1 frac sub mul 0 360
					{arc fill}stopped
					{cleartomark exch 1.3 mul dup setflat exch 2 copy gt{stop}if}
					{cleartomark exit}ifelse
				}loop
			}for
		}
		gsave stopped grestore
		{exch pop 2 index exch 1.3 mul dup 100 gt{cleartomark setflat stop}if}
		{exit}ifelse
	}loop
	cleartomark setflat
% leave path active
}bdf

% rfs & rfp composite defs: just call the core routine.
/rfs{_rfs}ndf
/rfp{_rfp}ndf


%-----------------------------------------------------------------------
% color functions
%-----------------------------------------------------------------------

/cvc [0 0 0 1] def	% dummy initial definition

% vc: set the current color to [color].
% used to be 'sc' but I changed it ('virtycolor') since some pinheaded
% old custom PS routines assumed that sc was the current stroke color.
% [color] vc --
/vc{
	AltsysDict /cvc 2 index put	% save the current color, so that user PS effects can look at it
	aload length 4 eq
	{setcmykcolor}
	{setspotcolor}
	ifelse
}bdf	% not ndf

% settextcolor: set the current color for text
% If the passed color is 100% black, automatically overprint it
% [color] settextcolor --
/settextcolor{
	dup vc 
	textblackopf	% only do this stuff if automatically overprinting black
	{
		aload length 4 eq		% only consider it if a process color
		{
			onlyk
			{1.0 eq{true setinkoverprint}if}
			{pop}
			ifelse
			pop pop pop
		}
		{pop pop}
		ifelse
	}
	{pop}ifelse
}ndf

%-----------------------------------------------------------------------
% define all the helpful things for images
%-----------------------------------------------------------------------

% save off default matrix -- required for OPI stuff
/origmtx matrix currentmatrix def
% go ahead and declare this guy here too.
/ImMatrix matrix currentmatrix def

% leave AltsysDict active

###### misc sep/doc trailer strings

%%EndSeparation: ^Q

######

%%Trailer

######

AltsysDict begin /SeparationSave save def end

######

SeparationSave restore

######

end

###### start definition of spot color array

% I don't know why we need to do this, but we have always done it
% this way, so I have just left it like this...
/currentpacking defed{false setpacking}if 	% want to do this prior to defining spots?

/spots[

##### for each overprinting spot color...

^0 (^2) true newcmykcustomcolor

##### for each non-overprinting spot color...

^0 (^2) false newcmykcustomcolor

###### end definition of spot color array

]def

###### code to clip to the doc's bbox/bleed (output for EPS files only)

^Z storerect left bottom width height rectclip

##### code at start of each page
%%Page: ^Z ^Z
#####
%%BeginPageSetup
%%PaperSize: ^Y
#####
0 setseparationgray
/imgr {^0} def			% image area
/bleed ^1 def			% bleed size
/clpr {^2} def			% clip rect
/xs ^3 def				% scale in x direction
/ys ^3 def				% scale in y direction
/botx ^4 def			% current horizontal position for color
/overlap ^5 def			% overlap for automatic tiling
/wdist ^6 def			% work dist used in calcs
^7 2 mul fhsetspreadsize	% autospread size
^8 0 ne {/df ^8 def /clipflatness ^8 def} if	% set default flatness
/maxsteps ^U def		% max number of gray steps to use

##### rotate the page if requested

% gee, it'd be nice to improve this to use setpagedevice (level 2) someday...
% for now, we use setpageparams if present, rotate/translate otherwise

statusdict /setpageparams known
{
% on the lino, use "0" for rotated and "1" for normal
statusdict begin ^0 ^1 ^2{exch}if 0 ^2{0}{1}ifelse setpageparams end
}
{
%^2 {90 rotate 0 ^3 neg translate}if
% this rotates the "correct" way, I hope
^2 {-90 rotate ^4 neg 0 translate} if
}ifelse

#####  mirror the page in x
^C ^A sub 0 translate
-1 1 scale

##### translate to lower left of printable area
^E ^F translate

##### set the requested scaling factor 
^3 ^3 scale

##### translate for this particular tile
^I ^J translate %. translate for this tile
^K xs div ^L ys div translate %. center on paper

##### extra translation for margin marks
^M xs div ^N ys div translate %. extra translation for margin marks

##### end of page setup code
%%EndPageSetup

##### titles at top of page
save
clpr storerect
left top wdist 1 add ys div add moveto
/Helvetica findfont 8 ys div scalefont setfont
(^a   ^b) show
restore

##### titles at top of page (row & col)
save
clpr storerect
left top wdist 1 add ys div add moveto
/Helvetica findfont 8 ys div scalefont setfont
(^a   ^b   Row ^c of ^d     Column ^e of ^f) show
restore

##### color sep name at bottom of page
save
clpr storerect
left botx xs div add bottom wdist 1.5 mul 1 sub ys div sub moveto
/Helvetica findfont 8 ys div scalefont setfont
(^Q) show
restore

##### cut marks
%. cut marks
save

imgr storerect
clpr /cliptop xdf /clipright xdf /clipbottom xdf /clipleft xdf

left bleed sub clipleft sub abs xs mul 1 le 
bottom bleed sub clipbottom sub abs ys mul 1 le and
{gsave left bottom moveto cm grestore} if

left bleed sub clipleft sub abs xs mul 1 le 
top bleed add cliptop sub abs ys mul 1 le and
{gsave left top moveto 1 -1 scale cm grestore} if

right bleed add clipright sub abs xs mul 1 le  
top bleed add cliptop sub abs ys mul 1 le and
{gsave right top moveto -1 -1 scale cm grestore} if

right bleed add clipright sub abs xs mul 1 le 
bottom bleed sub clipbottom sub abs ys mul 1 le and
{gsave right bottom moveto -1 1 scale cm grestore} if

restore

##### alignment marks
%. alignment marks
save

imgr storerect
clpr /cliptop xdf /clipright xdf /clipbottom xdf /clipleft xdf

top bleed add cliptop sub abs ys mul 1 le 
{left right add 2 div top bleed add 9 ys div add am} if

bottom bleed sub clipbottom sub abs ys mul 1 le 
{left right add 2 div bottom bleed sub 9 ys div sub am} if

left bleed sub clipleft sub abs xs mul 1 le 
{left bleed sub 9 xs div sub top bottom add 2 div am} if

right bleed add clipright sub abs xs mul 1 le 
{right bleed add 9 xs div add top bottom add 2 div am} if

right bleed add clipright sub abs xs mul 1 le 
{right bleed add 9 xs div add 20 ys div bottom add am} if

%. color bars
top bleed add cliptop sub abs ys mul 1 le 
{left right add 2 div top bleed add 9 ys div add fhcb} if

restore

##### overlap marks:
%. overlap top alignment markers
save
clpr storerect
gsave 
left wdist 2 div xs div sub top overlap 2 div ys div sub moveto 180 rotate overlapmark 
grestore
gsave 
right wdist 2 div xs div add top overlap 2 div ys div sub moveto 180 rotate overlapmark 
grestore
restore

#####
%. overlap bottom alignment markers
save
clpr storerect
gsave 
left wdist 2 div xs div sub bottom overlap 2 div ys div add moveto overlapmark 
grestore
gsave 
right wdist 2 div xs div add bottom overlap 2 div ys div add moveto overlapmark 
grestore
restore

#####
%. overlap right alignment markers
save
clpr storerect
gsave 
right overlap 2 div xs div sub top wdist 2 div ys div add moveto 270 rotate overlapmark 
grestore
gsave 
right overlap 2 div xs div sub bottom wdist 2 div ys div sub moveto 270 rotate overlapmark 
grestore
restore

#####
%. overlap left alignment markers
save
clpr storerect
gsave 
left overlap 2 div xs div add bottom wdist 2 div ys div sub moveto 90 rotate overlapmark 
grestore
gsave 
left overlap 2 div xs div add top wdist 2 div ys div add moveto 90 rotate overlapmark 
grestore
restore

#####
% set clipping path to image area.
% note: we need to do this after all the alignment mark stuff, I think.
clpr storerect left bottom width height rectclip

##### code at end of each page

%%PageTrailer

#####
%--------------------
% transfer functions.
%--------------------

currenttransfer concatprocs st

#####

%. erase page after inverting so that background is
%. inverted by default.
1 setgray -32000 -32000 64000 64000 rectfill
/inverted? true store

#####
% "Default" transfer -- nothing to do.
{}

#####
% Posterize transfer
{dup .5 le{.25 le{0}{.33}ifelse}
{.75 le{.67}{1}ifelse}ifelse}bind

#####
% Default inverted
{1 exch sub} bind

#####
% Posterize inverted
{dup .5 le{.25 le{1}{.67}ifelse}
{.75 le{.33}{0}ifelse}ifelse}bind

#####
% halftone strings
% default halftone
currentscreen exch pop exch pop
#####
% round dot halftone
{dup mul exch dup mul add 1 exch sub}

#####
% line halftone
{exch pop abs 1 exch sub}
#####
% elliptical halftone
{dup 5 mul 8 div mul exch dup mul exch add sqrt 1 exch sub}

##### 
% code to get current htone settings
currentscreen pop pop	% freq
#####
currentscreen pop exch pop % angle

#####

% ----------------------------------------------
% PS for the "Custom" fills and lines.
% On the Next, these aren't very "Custom",
% but hey, why spoil a good name?
% ----------------------------------------------

% Support routines ------------------------------------------
% this dictionary 'supdict' contains defs and routines used by several (or all)
% of the various custom ps effects.
/supdict 65 dict def % setup dict for support stuff
supdict begin % start putting things in this dict

/str1 512 string def     % string variable 
/dx 500 def     % def width of path bbox
/dy 700 def     % def height of path bbox
/cnt 0 def     % loop counter

% makes current path clipping path, translates to lower left 
% corner of bounding box of path, sets variables dx and dy, 
% inits random # generator and path
/newinside 
{ % 'fp' defined internally by FH to bump PS 'flatness' til #of path pts fits under limit
  % 'clipper' defined to be 'clip' or 'eoclip' depending on current fig's eorule
 {flattenpath}fp clipper pathbbox
 1 index 4 index sub round cvi /dx xdf
 0 index 3 index sub round cvi /dy xdf
 pop pop translate 222 srand n } def

/randint { 
 rand exch mod } def

/rand8 { rand -16 bitshift 255 and} def

/rand2 % randomly(?) generate 2 bit #
{ rand -16 bitshift 3 and } def

/brandxy {
 dx randint dy randint } def

/x1  % half of rotated bounding box width...
{ angle cos abs dx mul } def

/x2  % ...the other half
{ 90 angle sub cos abs dy mul } def 

/y1  % half of rotated bounding box height...
{ angle sin abs dx mul } def

/y2  % ...the other half
{ 90 angle sub sin abs dy mul } def

/backgnd % create single color background
{ xstart ystart m
  xstart ystart abs L
  xstart abs ystart abs L
  xstart abs ystart L
  closepath fill } def 

/incrcnt  % increment loop counter
{ /cnt cnt 1 add def } def

% set current color dependent on user input of single # or, 2 or 4 # array
/colorchoice
{
 /found false def  % init flag var
 gray? 
 {/CCblack [0 0 0 0] def
 color 1 exch sub
 CCblack 3 3 -1 roll put
 CCblack vc} % simple gray level (expressed as real or int)
 {color length 2 eq
  {color 1 get type (text) type eq    
   {0 1 spots length 1 sub
    {/cnt xdf      % loop index
    spots cnt get 4 get color 1 get eq 
     {/found true def exit} if % compare vs. user's
    } for
   % stuff index of found spot color in array; default - black 
   found {color 1 cnt put} {color 1 3 put} ifelse
   } if % has index already been found? 
  color vc 
  } if % spot color specification
 color length 4 eq {color vc} if   % process color
 } ifelse 
} def

/gray?  % does user entry indicate he wants color or gray ?
{ color type 0 type eq color type .0 type eq or } def 

end % end of supdict

#####

% PS defining 'ropedict' and relevant helper functions.

/ropedict 85 dict def  % dictionary for rope stuff
% this dictionary 'ropedict' contains stuff used only when constructing a newrope.
ropedict begin   % let's put these in the new dict.

/blocksetup
{ q translate rotate scale n } def % used to be gsave colorchoice translate

/blockend
{ closepath fill } def

/blockfinish
{ closepath fill Q } def

% following are functions used by rope.... procs for pathforall
/movetoproc { % move function
  dup /sby xdf %start-block y
  /spy xdf        %start-path y
  dup /sbx xdf %start-block x
  /spx xdf        %start-path x
  sbx sby m
} def

/1stlinetoproc % sum total length of flattened path
{ /esy xdf  /esx xdf % stack: xcur,ycur
  blockdata  % calc segment length
  /totdist totdist dist add def
  % make next seg start pt this one's end pt
  /sbx esx def  /sby esy def
  deltax 0 ne deltay 0 ne and
  { /prevtotdeltax deltax def  /prevtotdeltay deltay def } if
} def

/2ndlinetoproc % draw blocks where necessary along flattened path
{ /esy xdf  /esx xdf  % stack: xcur,ycur
  % calc segment length
  bdflag false eq 
  {blockdata esx spx eq esy spy eq and{lastsegdist}if}if  
  % draw block if we're far enuf along path
  offset ldelta add dist le  
  { % calc avg ang of blocks this segment   
    deltax 0 eq deltay 0 eq and
 {/ang 0 def}{/ang deltay deltax atan def}ifelse
    % correct for sharpness of angle between adjacent segments 
    % if offset is negative (120 - experimental inclusive angle)
 offset 0 lt 
 {/prevang prevdeltax 0 eq prevdeltay 0 eq and
  {0}{prevdeltay neg prevdeltax neg atan}ifelse def
  ang prevang sub abs dup 120 le exch 240 ge or
  {/offset 0 def bdflag true eq
   { % if we've reset offset AND on last segment, refigure distance
     % for last segment again
  lastsegdist
   }if 
  }if
 }if
    % draw as many blocks as fit in current segment
 offset ldelta dist
 {/curdelta xdf  % current dist into segment
  /ldeltax ang cos curdelta ldelta 2 div add mul def
  /ldeltay ang sin curdelta ldelta 2 div add mul def
  bll2 blw ang sbx ldeltax add sby ldeltay add drawblock
  /offset curdelta ldelta add dist sub def
  % stop drawing when space needed for block exceeds that available
  % this segment (factoring in amount for PS roundoff errors)
  ldelta offset abs .001 add gt {exit} if
 }for
    % retain current ang info for next segment & reset it
 /prevdeltax deltax def  /prevdeltay deltay def
   /deltax 0 def  /deltay 0 def
 % start next seg from end pt of this one
    /sbx esx def  /sby esy def  
  }if
}def

/1stcloseproc  % close function for 1st pass over path
{ spx spy 1stlinetoproc
}def

/2ndcloseproc  % close function for 2nd pass over path
{sbx spx ne sby spy ne or{
 % due to diffs in actual block drawing path and 'flattened' PS
 % path, final segment can be off by accumulated amount. Correct
 % for this by forcing enuf dist to fill final seg with blocks.
 /esx spx def  /esy spy def blockdata  /bdflag true def lastsegdist
 spx spy 2ndlinetoproc}if
}def
 
/blockdata % calc stuff needed by 2ndlinetoproc
{ /deltay esy sby sub def  % get segment distance
  /deltax esx sbx sub def
  /dist deltay dup mul deltax dup mul add sqrt def
}def

/lastsegdist  % special case distance computation for last segment
{/dist dist offset sub ldelta div round ldelta mul offset add def
}def

end   % done putting things in ropedict

% new and improved rope supports spacing value between blocks and 
% better path tracking by justifying to entire path instead of on
% per line segment basis
/newrope  % stack: procname blocklength blockwidth spacing color
 {
 supdict begin  % allow access to support procs and vars
 ropedict begin   % get special procs out of ropedict
 /color xdf 
 colorchoice
 /spacing xdf
 /blw xdf % block width
 /bll xdf % block length
 /drawblock xdf
 % 'fp' defined internally by FH to bump PS 'flatness' til #of path pts fits under limit
 q {flattenpath}fp
 /totdist 0 def   /totdeltax 0 def  /totdeltay 0 def
 % sum the path length in this first pass
 {movetoproc} {1stlinetoproc} {} {1stcloseproc} pathforall
 /nm totdist bll spacing add div def 
 /nm2 nm floor def  % calc #of blocks on path
 nm2 0 ne
  {
  /fr nm nm2 sub def  % fr is fraction of block extra
  % if fr < .5, stretch them, else shrink them
  /nm2 fr 0.5 ge {nm2 1 add} {nm2} ifelse def 
  /bll2 fr 0.5 ge {fr 1.0 sub} {fr} ifelse 
  bll spacing add mul nm2 div bll add spacing add def 
  /ldelta bll2 def % hold onto raw dist between blocks
  % take spacing value into account for scaling x dimension
  /bll2 bll2 bll bll spacing add div mul def
  % init some vars for 2nd pass over line
  /offset 0 def  /totdeltax 0 def  /totdeltay 0 def  /cnt 0 def
  /prevtotdeltax 0 def  /prevtotdeltay 0 def  /bdflag false def
  % now that we know spacing between blocks on path, pass over
  % it again, dropping blocks at each center pt 
  {movetoproc} {2ndlinetoproc} {} {2ndcloseproc} pathforall
  } if
 Q n end end  % ropedict & supdict
 } def

#####

% this dictionary 'texturedict' contains texture (image) patterns, and routines
% used only when drawing textures.
/texturedict 50 dict def
texturedict begin
/scalefactor .24 def
/angarray [0 90 180 270] def
/imagesize 72 def
/scaledsize
	{
	imagesize scalefactor mul 
	} def
/angget
	{
	angarray aryindex get 
	} def
/xtransget
	{
	xtrans aryindex get 
	} def
/ytransget
	{
	ytrans aryindex get 
	} def
	
% new imageloop routine using font calls for bitmaps

/imageloop				% loop across width and
	{
	0 scaledsize dy		% up height
		{
		/ycur exch def 
		0 scaledsize dx		
			{
			/xcur exch def
			gsave
			xcur ycur translate		% go to current x,y offset
			/aryindex rand2 def	% randomly rotate image
			angget rotate
			xtransget ytransget translate	% translate again
			imagesize imagesize scale	% based on rotation
			0 0 moveto
			(a) show
			grestore
			} for
		} for 
	} def
end

/invbuf{
	0 1 
	2 index length 1 sub
	{
		dup				% stack: i i
		2 index exch 	% stack: i buf i
		get 			% stack: i bufelem
		255 xor			% stack: i bufelem'
		2 index 		% stack: i bufelem' buf
		3 1 roll put	
	}
	for
}bdf

/settexturepattern
	{
	texturedict pattern get
	invflag
		{
		dup length /str2 exch string def str2 copy invbuf
		} if
	/pattern xdf
	} bdf

/texture	% stack: (pattern), color
	{
	% fill the path with white, so we get an opaque texture
	gsave
	[0 0 0 0] vc
	filler	% defined as fill or eofill depending on current eorule
	grestore
	supdict begin  % access support routines 
	/txsave save def
	newinside
	vc  % set color
	texturedict begin
	/pattern xdf  % pattern to draw
	/invflag false def
	pattern (burlap) eq		% bitmap size of image patterns
		{
		/imagesize 144 def 
		} 
		{
		/imagesize 72 def 
		} ifelse
	pattern (light-mezzo) eq
		{
		/invflag true def
		} if
	pattern (light-mezzo) eq pattern (heavy-mezzo) eq or
		{
		/pattern (mezzo) def
		} if
	% build the texture font
	9 dict begin
	/FontType 3 def
	/FontMatrix [1 imagesize div 0 0 1 imagesize div 0 0] def
	/FontBBox [0 0 imagesize imagesize] def
	/PaintType 3 def
	/Encoding 256 array def
	0 1 255
		{
		Encoding exch /.notdef put
		} bind for
	Encoding 97 /thetile put
	/CharProcs 2 dict def
	CharProcs begin
	/.notdef
		{
		} def
	/thetile
		{
		imagesize imagesize true 
		[imagesize 0 0 imagesize 0 0] 
			{
		    pattern
			} systemdict begin imagemask end
		} def
	end
	/BuildChar
		{
		imagesize 0
		0 0 imagesize imagesize
		setcachedevice
		exch begin
		Encoding exch get
		CharProcs exch get
		end
		exec
		} bdf
	currentdict
	end
	/TextureFont exch definefont pop
	/xtrans [0 0 scaledsize neg scaledsize neg] def		
	/ytrans [0 scaledsize neg scaledsize neg 0] def	
	/TextureFont findfont scaledsize scalefont setfont
	pattern (burlap) eq pattern (denim) eq or
		{
		pattern (burlap) eq 
			{
			settexturepattern
			burlapimageloop
			} 
			{
			settexturepattern
			denimimageloop
			} ifelse
		}
		{
		settexturepattern
		imageloop
		} ifelse 
	txsave restore
	end 
	end 
	} def
	
#####

% code for "bricks"

supdict begin

/getwidth % make 'mortar' multiple of largest brick dimension 
{ xsize ysize ge
  { xsize } { ysize } ifelse .05 mul } def

% draw 'mortar' lines, staggering verticals on successive horizontals
/brickloop  
{ ystart ysize ystart abs 
  { /ycur xdf  % stack: ycur
    xstart ycur m 
 xstart abs ycur L stroke
 xstart xsize xstart abs  % stack: xcur
 { cnt 1 and 0 eq  % stagger verticals per mortar row
   { /xcur xdf } 
   { /xcur exch xsize .5 mul add def } ifelse
   xcur ycur m
   xcur ycur ysize add L stroke 
 } for
 incrcnt
  } for } def

end  % supdict

/bricks  % stack: xsize, ysize, angle, mortar color, brick color
{
 supdict begin  % access support routines
 q newinside % current path becomes clipping path; other inits
 /color xdf
 colorchoice % set brick color
 /color xdf % mortar color
 /angle xdf % rotation angle
 /ysize xdf % brick dimensions
 /xsize xdf
 /xstart x1 x2 add 2 div neg def % starting x coord
 /ystart y1 y2 add 2 div neg def % starting y coord
 % set up coord space to handle rotation
 dx 2 div dy 2 div translate
 angle rotate
 backgnd % fill clipping path with brick color
 colorchoice % set mortar color
 getwidth w
 brickloop  % create bricks by drawing mortar lines
 Q end 
} def

#####

% "tigerteeth"

supdict begin

/teethsize % y offset for each tooth
{ dy teeth div } def

/drawtooth % draw individual tooth
{ dx teethsize 2 div rlineto
  dx neg teethsize 2 div rlineto } def 

/teethloop % control drawing of each tooth
{ teeth { drawtooth } repeat } def

/sfx % x scale factor
{ x1 x2 add dx div } def

/sfy % y scale factor
{ y1 y2 add dy div } def

end  % supdict

/tigerteeth  % stack: #of teeth, angle, teeth color, bkgnd color
 {
 supdict begin  % access support routines
 q newinside % current path becomes clipping path; other inits
 /color xdf
 colorchoice    % set background color
 /color xdf  % teeth color
 /angle xdf   % rotation angle
 /teeth xdf  % #of teeth
 % align clip bbox center with teeth center for rotation; scale
 % teeth based on angle
 dx 2 div dy 2 div translate
 angle rotate
 sfx sfy scale
 /xstart dx 2 div neg def
 /ystart dy 2 div neg def
 backgnd % fill clip path with background color  
 colorchoice  % set tooth color
 xstart ystart m teethloop fill  % draw teeth  
 Q end
 } def

#####

supdict begin
/circloop  % fill clip area with circles
{ ystart spacing ystart abs 
  { /ycur xdf % get current y loc
    xstart spacing xstart abs 
 { % load stack with current x & y & stroke circ
   ycur size 0 360 arc stroke
 } for
  } for } def
end  % supdict

/circles % stack: size, spacing, angle, linewidth, circle color
 {
 supdict begin  % access support routines 
 q newinside % current path becomes clipping path; other inits
 /color xdf
 colorchoice % set circle color and linewidth
 w
 /angle xdf % rotation angle
 /spacing xdf % space between circle centers
 /size xdf % circle radius
 % set up coord space to handle rotation
 /xstart x1 x2 add 2 div neg spacing sub def % starting x coord
 /ystart y1 y2 add 2 div neg spacing sub def % starting y coord
 dx 2 div dy 2 div translate
 angle rotate circloop % draw the circles
 Q end
 } def

#####

supdict begin
/squareloop  % fill clip area with squares
{ ystart spacing ystart abs 
  { /ycur xdf % get current y loc
    xstart spacing xstart abs 
 { % load stack with current x & y & draw square
   ycur m
      size 2 div neg size 2 div neg rmoveto
      0 size rlineto
      size 0 rlineto
      0 size neg rlineto
      closepath stroke
 } for
  } for } def
end  % supdict

/squares % stack: size, spacing, angle, linewidth, square color
 {
 supdict begin  % access support routines 
 q newinside % current path becomes clipping path; other inits
 /color xdf
 colorchoice % set square color and linewidth
 w
 /angle xdf % rotation angle
 /spacing xdf % space between square centers
 /size xdf % side length
 % set up coord space to handle rotation
 /xstart x1 x2 add 2 div neg spacing sub def % starting x coord
 /ystart y1 y2 add 2 div neg spacing sub def % starting y coord
 dx 2 div dy 2 div translate
 angle rotate squareloop % draw the squares
 Q end
 } def

#####

supdict begin
/dashpat [12 3] def   % pattern for dashed lines
/lineloop % fill clip area with lines
{ ystart spacing ystart abs
  { /ycur xdf  % stack: ycur
 dashes?   % do staggering stuff for dashed lines
 { % set dash pattern to stagger lines
    cnt 1 and 0 eq { dashpat 0 setdash } 
 { dashpat dashpat 0 get dashpat 1 get add 2 div setdash } 
 ifelse } if
    xstart ycur m
 xstart abs ycur L
    stroke incrcnt
  } for } def
end  % supdict

% new and improved hatching that supports dashed line patterns
/newhatch  % stack: 1st angle, 2nd angle, spacing, linewidth, linecolor, dashes?
 {
 supdict begin  % access support routines 
 q newinside
 /dashes? xdf % dashed or solid line ?
 /color xdf
 colorchoice  % set drawing color & linewidth for lines
 w
 /spacing xdf  % space between each line
 /ang2 xdf % angle from horiz for 2nd grid line
 /angle xdf  % angle from horiz for 1st grid line
 % set up coord space to handle rotation
 % yes, these need to be procs since x1,x2,y1,y2 are procs which depend on /angle
 /xstart {x1 x2 add 2 div neg} bdf % starting x coord
 /ystart {y1 y2 add 2 div neg} bdf % starting y coord
 dx 2 div dy 2 div translate
 q angle rotate
 lineloop Q % draw lines
 ang2 angle sub abs 180 ne  % draw 2nd set of lines for grid if nec.
  {
  ang2 rotate  % rotate again for 2nd half of grid
  % redefine angle var for x & y starts
  /angle ang2 def 
  lineloop 
  } if
 Q end
 } def 

#####

supdict begin
/leaf { 
 brandxy  translate 
 360 randint rotate
 /wid 10 randint 15 add def
 0 0 m
 0 wid 0 wid wid wid C
 wid 0 wid 0 0 0 C } def
end  % supdict

/randomleaves 
{supdict begin  % access support routines 
newinside 
{q leaf 
 [0 0 0 0] vc q fill Q
 [0 0 0 1] vc 1 w stroke Q 
} repeat end 
} def

#####

supdict begin
/blade { 
 brandxy  translate 
 /wid 5 randint 5 add def
 0 0 m
 0 3 3 10 wid 10 C } def
end % supdict

/randomgrass
{supdict begin  % access support routines 
newinside q
[0 0 0 1] vc
 {q blade
 1 w stroke Q 
 } repeat end 
Q
} def

#####

/newnoise  %  stack: min-white max-white
{ supdict begin  % access support routines 
  q newinside
  [0 0 0 1] vc
 /mx exch 255 mul cvi def  % convert from fractional gray to 0-255 range
 /mn exch 255 mul cvi def % ditto
 /dff mx mn sub def
 dx dy scale 
 dx dy 8 [ dx 0 0 dy 0 0 ]
  { 0 1 511{ str1 exch rand -16 bitshift 255 and dff mod mn add put } for str1} 
 image Q end } def

#####

/bwnoise  
{supdict begin  % access support routines 
q newinside 
[0 0 0 1] vc
dx 1.5 mul  dy 1.5 mul scale 
dx dy 1 [ dx 0 0 dy 0 0 ]
{0 1 511 {str1 exch rand8 rand8 or put} for str1} 
image Q end 
} def

#####

/topnoise 
{ supdict begin  % access support routines 
  q newinside  
  dx 1.5 mul  dy 1.5 mul scale 
  dx dy  true [ dx 0 0 dy 0 0 ]
  { 0 1 511{ str1 exch rand8 rand8 and put } for str1} 
  imagemask Q end } def

######

/neon 
{ supdict begin  % access support routines 
  /wd xdf 
  q wd w 0.5 setgray stroke Q
  q wd 2 div w 0 setgray stroke Q
  q 1 w 1 setgray stroke Q n end } def

#####

texturedict begin
/burlapimageloop
{ 0 scaledsize dy
{ /ycur xdf
0 scaledsize dx
{ /xcur xdf
gsave
xcur ycur translate
/aryindex rand2 def
aryindex 1 and 0 eq
{ angget rotate
xtransget ytransget translate } if
imagesize imagesize scale
0 0 moveto
(a) show
grestore
} for
} for } def

/burlap
< 
FC 00 00 00 07 E0 00 00 00 FC 00 00 00 7E 00 00 00 3F 
E1 FE 0E 00 23 FC 00 00 3F FC 03 FF FF BF FF FF F0 0F 
C0 7F 1F 80 21 F8 00 3E 3F EC 03 FF FE 31 FF FF 38 07 
C0 7F FF C0 71 F8 01 FF FF CC 07 FF FE 01 BF FF 08 07 
E9 FF FF C1 F9 FF F3 FF FF C6 07 FF FC 00 1F FF 08 07 
E3 FF FF C0 79 FF FF FF FF 86 07 FF 88 00 4F FF 88 07 
F3 FF FF 60 39 FE 01 FF FF 82 03 FF CE DC 0F FF D0 3F 
F0 FF FF 20 79 FE 21 FF FF 98 03 FF FF 84 0F FF E0 7F 
D0 7F FF 00 79 FF F8 1F FF 9D 03 FF FF 00 07 FF E0 FF 
90 7F FF 00 7F FF E0 07 FF 8E 03 FF FF 00 07 FF E0 7F 
10 FF FF 01 FF FF C0 07 FF 98 03 FF FC 00 07 FF E0 7E 
30 FF FF 87 FF FF C0 07 FF F1 87 FF FC 00 0F FF F0 FA 
70 3F FF E1 FF FF 80 03 FF 80 C7 FF FE 00 1F FF FF F0 
78 3F FF F1 FF FF C0 03 FF 80 FF FF FC 00 2F FF FF F0 
78 3F FF F3 FF FD 80 13 FF C7 FF FF FC 10 0F F9 FF FC 
78 7F FF FF FF F8 80 1F FF FF FF FF FC 10 0F F8 81 3E 
78 FF 8F FF FF F8 00 1F FE C7 FF FF FC 00 07 F0 00 0E 
78 F6 00 3F FF FE 00 1F 00 80 7F FF FE 00 70 E0 00 06 
38 E0 00 0C FF FE 00 3E 00 00 01 FF FC 00 FF 80 00 00 
10 E0 00 10 00 FE 00 1E 02 00 00 3F FC 61 FF C0 00 00 
00 60 00 20 00 3E 00 1E 06 00 00 3F FF C3 FF C0 00 00 
00 20 00 00 00 1C 00 FE 00 00 00 78 FF 8F DF C0 00 60 
00 00 00 00 00 0F 8F FC 00 00 00 60 7F 1F 1F C0 00 60 
0C 00 40 00 00 1F F4 1C 00 00 00 00 FF 3E 13 C0 01 F8 
1C 00 40 00 00 4F E0 00 00 00 00 00 FF FE 11 C3 E7 FC 
7F 00 40 00 00 EF 60 00 04 00 00 21 FB FE 01 FF FF FE 
7E 00 40 00 00 7F 00 00 3C 00 00 63 F0 3E 01 FF FF FE 
7C 0C C0 00 00 FF 00 01 FE 00 02 FF E0 0C 01 FF F8 FE 
40 0F E0 00 01 FF 80 07 FF 39 E3 FF E0 00 01 FF F8 06 
18 0F FF FF 9F FF C0 0F FF FF FF FF EF 00 01 FF 80 00 
98 1F FF F9 FF FF C0 1F FF FF FF FF FF F0 01 FF C0 03 
98 1F FF FB FF FF C0 7F FF FF F8 FF C9 FF B3 FF C0 0F 
F8 1F FF FA 0F FF 80 7F FF FF F0 7F F8 7F FF FF 60 0F
F8 3F FF F0 0F FF 83 FF FF FF E0 3F FF FF FF FE 30 07 
F8 3F FF F0 1F FF 83 FF FF FF E0 1F FF FF FF FC 30 03 
F8 7F FF E0 3F F8 03 FF FF F9 F0 1C 7F FF FF F8 10 03 
F0 3F FF C0 1F C0 00 FF FF F8 70 38 70 01 FF F8 10 C3 
FE 1F FF C0 1F 00 00 0F FF FF 30 30 00 00 18 00 18 F7 
FF 3F FF C0 0E 00 00 01 FF FF 94 30 00 00 03 80 0C F7 
F8 0F FC C6 06 00 00 03 FF 90 0C 30 00 00 01 C6 00 7F 
F8 03 FC 00 06 00 00 00 FF 90 1C 20 00 00 01 E1 88 7F 
F0 00 FC 01 C2 00 00 00 FF F0 18 02 00 00 03 F0 7C 3F 
80 00 1D 80 E2 00 00 00 EF F8 18 07 80 00 03 F8 10 1F 
80 00 1F C0 62 00 00 01 8F F1 18 1F 80 00 43 FF 10 1F 
00 00 1F E0 03 00 00 03 9F F0 3C 1F E0 03 8F FF 88 0E 
00 00 1F FC 03 C7 FF FF DF F0 1C 1F FF FF FF FF C8 00 
1F E0 3F FC 03 CF F7 77 FF FE 06 3F FF BC 1F FF F8 20 
1F 8C FF FC 03 FF 81 21 FF FF 07 7F FF F0 1F FF 90 38 
3C 04 7F FC 03 FF 80 00 FF FF 07 FF FF E0 0F FF 80 1C 
78 00 7F F8 03 FF F0 00 FF F8 20 FF FF E0 07 FF E0 1E 
78 00 FF F8 03 FF E0 00 7F F8 03 FF FF F0 07 FF F8 7E 
30 00 7F F8 07 FF E0 00 3F FC 0F FF FF E0 07 FF FC 7E 
70 00 3F F8 0F FF E0 00 3F FE 0F 7F FF E0 0F FF E0 7E 
70 00 3F F9 FF FF F0 00 FF FF 1C 7F FF E0 1F FF F4 3E 
60 00 3F FF BF FF F0 01 FF FF F8 7F FF C0 03 FF FE 2E 
78 00 7F FE 3F FF F0 00 FF FF B0 3F FF 80 03 F0 00 0E 
70 04 7F FE 7F FF F0 00 FF FE F0 1F FF 80 03 E0 00 3E 
70 07 FE 43 FF FF 00 00 FF B8 0E 0F F0 80 07 E0 01 FE 
70 07 C0 03 FF FF C0 03 FC 00 03 CF F0 00 1F C0 07 FC 
70 07 C0 04 BF FF C0 03 D0 00 00 FF FE 40 3F 80 00 18 
70 07 80 18 9F FF C0 1F C0 00 00 7F FF 80 FF 00 00 0C 
70 07 80 7C 00 3F C0 1F 80 00 00 6F FF 01 FF 80 03 80 
70 07 80 E4 00 7F C0 1E 00 00 00 CF FF 00 79 80 00 00 
71 03 83 C0 00 FF C0 1E 00 00 C1 1F FF C0 11 80 00 02 
71 00 87 C0 01 9F CE 1C 00 01 E0 3F FF E0 00 00 00 06 
FF 00 8F C0 01 99 FF 00 22 1F E0 3F FF C0 00 01 FE 03 
FD 00 DF C0 03 9B FF 00 FF 1F 80 1F FF E0 00 7F FF EF 
FC 01 FF C0 07 FF FF 00 FF FF 80 3F FF F0 01 FF FF E7 
FC 01 FF FF FF FF FF 00 FF C6 03 FF FF F8 01 FF FE 0F 
F8 03 FF FF FF FF FF 00 FF FF FF FF FF F8 01 FF FC 07 
F8 03 FF FF FF FF FC 00 FF FF FF BF FF F8 01 FF FC 07 
FC 03 FF FF C7 FF 20 03 FF FF FF 3F FF F8 01 FF FC 0F 
FC 07 FF F3 03 FF 10 0F FF FF FE 39 FF F0 03 FF FE 0F 
F8 0F FF C0 00 FF B0 FF FF FF F8 13 FF F0 03 FF FE 1F 
F8 3F FF C0 01 FF F1 F9 FF FF F8 87 FF E0 47 FF FE 1F 
F0 3F FF F0 03 FF F9 C1 FF FF F8 07 FF F0 07 FF FE 1F 
F8 3F FF F8 03 FF FF 83 FF FF 7C 07 FF F8 07 FF FE 1F 
F8 3F FF F8 03 FF FF 1F FF FF 78 03 FF F0 2F FF FE 0F 
BC 7F FF E0 03 FF FF FF FF FF F0 03 DF F1 FF FF FF 0F 
1F FF FF E0 03 FF FF FF FF FF 90 03 8F F3 FF FF FF 0A 
1F FF FF C0 07 FF FF FF FF FF C0 07 0F FF FF FF FF 02 
1F FF FF C0 0F E3 F7 FF FF FF C0 0F 1F FF 3F FF FC 02 
0E 7F FF C0 0F C2 01 FF FF FF 80 BF 3E 00 1F FF FC 00 
00 7F FF 80 07 F8 03 F8 67 BF 80 EF FC 00 00 07 F8 30 
00 07 FF 00 67 E0 07 C0 00 07 00 FF FC 00 00 00 18 78 
00 00 7E 00 73 80 0C 00 00 01 00 FF BE 00 00 00 00 F8 
00 00 1C 01 F3 00 10 00 00 01 80 FD DF 00 00 00 01 F8 
00 00 18 01 F0 00 00 00 00 01 00 7C FF C0 00 06 0F F0 
0F 80 18 1F E0 00 00 00 00 0E 04 7F FF C0 00 1E 0F E0 
0F 00 11 98 60 00 00 00 00 1C 04 7C CF E0 00 7E 3F 00 
1F 01 11 80 00 E0 01 84 00 1C 20 3C 07 F0 60 7F FC 00 
3F 03 B1 80 07 FF FF FF 40 1D F0 0C 41 FF BC FF F8 00 
3E 7F FB F0 0F FF FF C1 8F FF FC 00 61 FF 81 FF F8 0C 
3F FF FF C0 0F FF FF C1 FF FF FC 01 E7 FF E0 FF FE 1E 
38 3F FF C0 1F FF FF C1 FF FF FC 07 FF FF E0 FF FE 1E 
30 3F FF E0 7F FF FE 00 FF FF F8 07 FF FF F0 FF FE 1E 
38 3F FF E0 7F FF F8 00 7F FF F0 03 FF 3C 00 7F FE 3C 
38 1F FF E0 7F FF FC 00 3F FF F0 01 FF 3C 00 7F FE 30 
00 1F FF F0 FF FF FC 00 1F FF F0 01 FF FC 01 7F FC 00 
00 1F FE 01 FF FF FC 01 FF FF F0 01 FF FE 01 3F FC 00 
80 1F FF 00 7F FF FC 01 FF FF F0 01 FF FE 00 9F FC 00 
FE 0F FF 00 7F FF FE 04 FF FF F0 03 FF FE 00 5F FE 01 
FC 0F FF DE 7F FF FB 06 7F FF FE 7F FF FE 00 7F FF C3 
F8 0F FF FF FF FF F8 80 3F FF FF FF FF FF 00 7F FF 8F 
F8 07 FF FF FF FF FC 00 1F FF F3 FF FF FE 00 7F FF DF 
FC 03 FF FF FF FF FE 00 1F FF 81 FF FF FE 00 FF FF FF 
FE 0F BF BD FF FF FC 00 7F FE 01 FF FF FC 00 FF FF FF 
FE 1C 3E 10 FF FF F0 00 FF FC 00 FF FF F8 00 FF 81 FF 
FE 1E 7C 00 7F F3 F0 03 FA 38 00 FF FF C0 00 FE 00 3F 
FE 0F 8C 00 7F F3 E0 01 F8 00 00 9C FF C0 00 F0 00 3F 
FE 1F 00 00 03 FF 00 00 7E 00 00 00 FF C0 00 60 00 07 
FC 1F 20 00 01 FF A0 00 7F 00 00 01 FF C0 00 E0 00 0F 
F9 9F F0 00 00 9F F8 01 7F 00 00 00 7F C0 44 F0 00 8F 
F9 8F F0 00 00 1F FC 03 3F 00 78 00 7F E0 0C 70 00 1F 
39 C0 78 00 00 3F FC 00 1F 88 7C 00 FF E1 3E 00 07 FF 
21 80 20 00 00 3F FC 04 1F 80 0C 03 FF B3 3C 00 07 FC 
20 80 00 00 00 7F FC 20 1C 00 04 00 7F FF 38 00 07 F8 
18 03 00 00 00 8F FC 70 1C 00 02 00 1F FF B8 00 00 18 
4F 00 00 00 00 0F F8 70 38 00 01 00 1F FF 80 00 00 18 
7E 00 00 00 00 3F FF F0 30 00 01 00 7F FF 80 00 00 00 
7E 00 00 00 00 FF FF D0 30 00 01 80 7F FF 80 10 00 00 
3C 00 00 00 00 FF FE C0 30 00 00 00 3F E7 00 10 00 0C 
38 0C 00 00 07 FF FE 00 70 07 F0 00 3F EF 00 10 01 FC 
10 1F 00 00 1F FF FE 00 7F 9F F0 00 7F F8 00 1E 07 FC 
10 1F 00 00 3F FF FE 00 7F FF C0 0F FF F0 00 1F FF F0 
00 3F DF C0 0F FF FE 00 FF FF C3 9F FF F0 00 1F FF FC 
00 7F FF 80 1F FF FF C1 FF FF FF C3 FF F0 00 9F FF FC 
00 7F F7 98 7F FF E0 00 FF FF FE 01 FF F3 00 BF FF 00 
3F FF FF FC 03 FC 00 00 FF FF F0 01 FF FF 87 FF F8 00 
7F FF FF FE 01 F0 1F 80 3F FF F0 01 FF E0 07 FF F0 00 
7F FF FF F8 01 FF C3 C0 1F FF C0 03 7F FC 1F FF F0 00 
18 FF FF F0 01 FF 80 00 0F FF C0 02 7F FE 0F FF F8 38 
08 3F FF F0 03 FF C0 00 07 FF C0 00 7F FF EF FF F8 3C 
00 3F FF F0 03 C1 C3 80 03 FF F0 00 7F FF FF FF F0 74 
80 7F FF E0 03 C3 E7 FF 00 FF F8 00 77 F7 FF FF E0 61 
87 FF FF 80 0F 80 01 1F C0 7F F0 00 E0 01 FF FF C0 C3 
8F FF FF 80 0F 00 00 00 7F FF 60 00 E0 1F C3 FF C0 87 
E7 FF FF 80 1F 00 00 00 1F FE 00 00 00 09 07 FF E1 87 
F0 1D FC 80 3B 00 00 00 1F FE 00 00 00 00 07 FF E0 0F 
F0 00 FC 00 71 00 00 00 04 FC 00 0C 30 00 3F FF E0 3F 
F0 00 DC 01 FE 00 03 0C 1C 3F C0 19 E0 30 0E 03 C0 7F 
F8 00 00 01 FC 00 0F 80 03 FB C0 10 80 F0 28 03 80 7F 
F8 00 00 01 FC 00 1F C0 03 FB E0 20 00 F0 30 02 00 1F 
FC 00 00 00 3F 00 00 00 0F C0 00 00 01 F8 00 00 00 3F
> def

end  % texturedict 

######

texturedict begin

/outerloopcnt -1 def
/denimimageloop
{ 0 scaledsize dy
{ /ycur xdf
/outerloopcnt outerloopcnt 1 add def
outerloopcnt 1 and 1 eq
{ /cnt 0 def } { /cnt -1 def } ifelse
0 scaledsize dx
{ /xcur xdf
gsave
xcur ycur translate
incrcnt
cnt 1 and 1 eq
{ 180 rotate
scaledsize neg scaledsize neg translate } if
imagesize imagesize scale
0 0 moveto
(a) show
grestore
} for
} for } def

/denim 
< 
E6 66 66 66 66 66 66 66 67 F7 E7 E6 3F E6 66 66 24 66 
B2 66 66 77 62 22 32 2C 62 F3 27 E6 77 63 33 13 2C F2 
F3 F7 67 7F F3 FB 3F 0C F2 93 27 27 77 73 BB BF 9C F6 
99 27 26 23 33 33 9B 88 F6 FB E7 67 77 33 3B 9B 8C FE 
DB 27 67 77 33 3B 9B 0D F6 99 02 62 32 21 11 91 00 90 
FB 23 67 33 33 39 93 08 92 FB E7 E7 7F 73 3B FB 1D F2 
B3 27 67 32 33 31 B3 08 80 93 27 23 32 33 11 13 00 00 
BB E7 77 3F 33 BB 9B 08 D2 BB 26 23 33 33 B3 B3 09 F2 
11 02 22 02 21 11 12 00 00 FB E7 73 3B 33 11 93 09 90 
FB E7 77 3F 73 BB BB 1D F6 9B A3 22 33 33 31 93 19 F2 
9B 03 22 33 31 11 93 09 92 FB F3 33 3F 33 33 B3 99 F7 
B9 A3 33 33 33 11 92 09 F2 19 23 32 13 21 01 00 00 80 
B9 E3 33 33 33 11 99 08 B3 BB F3 37 33 33 B9 F9 19 F3 
99 A3 33 33 31 11 99 09 F3 9B B3 B7 3B 31 19 99 08 F3 
9B F3 B7 3F 3B B9 DB 1D FF 99 B3 33 33 31 19 99 08 F3 
BB F3 B3 3B 39 99 99 08 F3 FF F3 FF 3F BB B9 FF 9C F3 
9B F3 B7 3F BB B9 DF 9D FB 99 83 93 13 31 99 DB 8C F1 
9B F3 B3 3B B1 BD DB 8C F3 DF FF F3 3F B9 FD FF 9C FB 
99 F3 B1 19 19 98 D9 8C F3 9D F3 91 19 19 9C D9 8C 79 
FF FB FB 9F 99 DC FD 8C FB FF FB FB 9F 99 DD FD CE FB 
DD FB BB 9F 99 DC FD CE FB DD FF FB 9F 99 DC FF CE FF 
DD FB BB 9F 99 CC FF CE FF DC FB 99 9D 99 CC FD CE F9 
FF FF F9 DF DD DC FD CE F9 FF FB F9 DF DD DF FD CE FD 
CD F9 D9 DF 9D CD FD CE F9 CD D9 F9 DF 9D CC DD CE FD 
DD FD F9 DF DD EC FD CE FF 8C D8 99 8D 9C CC CD C6 FD 
0C C8 98 8D 9C CE FC C6 7C CF FD F9 CF DC EE FD CE 7F 
CF FD DD CF DC EE FD CE 7F CF FC 89 CC CC 4E 6C C6 3C 
EF FD CD CE CE E6 6D C6 3C FF FD FD CF CE E6 7F C6 7F 
6F FC CC CC CC E6 7D C6 3C 6F FC CC CE CC 66 6C C6 3C 
FF FC FD CF CE E6 7C CE 7C EE FC CD CF CC E6 7C CE 7F 
44 6C C8 C6 CC E6 64 C6 3C EE FC ED CF CE E6 74 C6 3C 
EF FE FD CF CF E6 7C C7 3F EE FE CC CE CC C6 7C C6 3E 
EE FE EC CE CC E6 7C C6 3E EE FC EC EF CC EE 7C CF 7F 
CC EC CC E6 CC E6 6C C6 3F 4E EC EC E6 CC E6 64 C6 3C 
E7 FC 6C EE CC E6 6C C6 77 46 EE 44 E6 CC E6 7C 46 37 
66 6E 4C 66 44 66 6E 46 36 E6 66 66 66 66 66 66 66 67
  > def

end  % texturedict 

#####

texturedict begin

/sand
< 
00 18 00 00 00 40 06 00 18 C0 00 00 60 00 00 00 00 00 
C0 00 00 20 00 00 00 00 00 00 00 00 00 06 00 60 00 00 
00 00 00 00 00 00 60 40 00 00 40 0C 02 00 00 00 60 00 
00 40 00 02 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 C0 00 00 00 00 00 18 00 00 00 
00 00 80 00 00 18 00 00 00 04 00 C0 00 00 00 04 00 00 
06 00 00 38 0C 00 06 00 00 00 00 00 38 0C 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 07 00 
00 00 00 00 00 01 00 03 00 00 00 00 00 00 00 00 00 06 
00 00 06 00 00 00 00 00 07 10 0C 04 00 00 00 00 C0 00 
10 08 00 01 80 00 00 80 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 C0 00 00 00 00 00 00 00 00 C0 00 00 00 
00 00 00 00 00 00 60 00 C0 00 00 60 30 00 00 00 00 C0 
00 C0 00 30 00 00 00 00 00 C0 00 00 00 10 00 00 C0 00 
80 00 00 00 10 00 00 C0 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 06 00 00 01 00 00 00 00 00 00 00 00 01 
00 00 60 20 00 00 00 03 81 00 60 60 30 00 00 00 03 80 
40 20 00 00 1C 00 00 00 00 60 00 00 00 18 00 07 00 00 
00 00 00 00 00 00 02 00 00 00 00 00 00 00 06 00 00 00 
00 00 00 00 00 02 00 00 00 00 00 60 30 00 00 00 00 00 
00 C0 60 10 00 00 00 00 60 00 C0 00 00 0C 00 00 00 70 
00 00 00 00 0C 00 01 80 00 00 00 00 00 00 00 01 80 00 
00 00 00 00 00 00 00 00 00 00 00 0C 00 00 06 00 00 00 
20 00 1C 08 00 00 00 00 04 30 00 18 0C 00 00 00 00 06 
00 30 00 00 00 00 00 10 00 00 20 00 00 06 00 00 10 00 
00 00 00 00 00 00 10 00 00 60 00 00 00 00 00 10 00 00 
00 00 00 00 00 00 00 00 00 00 00 01 80 00 00 00 00 00 
00 01 01 80 00 30 00 00 80 00 03 80 03 00 00 00 00 C0 
00 00 00 00 00 00 00 00 00 03 00 00 00 00 00 01 80 00 
03 00 00 00 0C 00 00 00 00 00 00 00 00 0C 00 00 00 00 
00 00 00 00 00 00 00 00 00 80 00 06 00 00 03 00 00 0C 
00 00 06 00 00 03 00 08 0C 00 04 00 00 00 00 00 0C 00 
00 06 00 06 00 00 00 00 00 00 00 00 00 00 00 08 00 00 
00 00 00 00 04 00 0C 00 00 01 80 00 00 06 00 00 00 00 
00 00 00 00 00 06 00 00 40 00 00 01 00 00 07 00 00 20 
00 00 03 80 00 00 00 60 00 00 03 00 00 00 00 00 20 00   
> def

end  % texturedict 

######

texturedict begin

/coarse-gravel
< 
00 00 00 00 60 00 70 00 00 00 00 3F 00 20 00 70 00 00 
80 00 FF F0 00 00 20 00 0C C0 03 F1 FC 01 80 00 06 04 
00 07 80 3F 03 C0 00 06 00 0E 0F 00 0F C0 00 00 03 00 
04 0F 00 03 C0 00 00 00 00 04 0E 00 01 E0 00 00 00 03 
00 1E 00 01 E0 00 0F 00 01 00 3E 00 01 E0 00 3F E0 00 
00 7C 00 FF E0 C0 7F F0 00 00 F8 01 FF C0 80 F0 F8 00 
00 F0 07 FF 80 00 E0 3C 00 01 C0 0F C0 00 01 E0 1E 00 
01 E0 3F 00 00 01 C0 0E 08 00 F0 7C 00 00 01 C0 0E 18 
00 7F F8 00 00 01 C0 0E 08 00 3F E0 00 00 00 C0 07 18 
00 0F C0 00 00 00 E0 07 00 1C 00 00 1C 00 40 78 03 00 
0C 00 00 1C 00 60 3E 03 00 00 00 00 1C 00 F0 1F 87 80 
00 00 00 0C 00 20 07 CF 80 00 00 00 00 00 00 07 FF 80 
00 20 00 00 00 00 01 FF 00 00 30 00 07 E0 00 00 FC 00 
00 00 00 1F F0 00 00 00 00 00 00 00 3F F8 00 00 00 00 
E0 00 00 FC 3C 00 00 00 03 60 00 01 F0 1C 00 08 00 03 
00 00 03 E0 1C 00 18 00 00 00 00 0F C0 1E 00 38 01 80 
00 00 1F 00 1E 00 00 03 80 00 00 3E 00 1E 00 00 00 00 
08 00 3C 00 1E 00 00 00 00 1C 00 78 00 1C 00 00 00 00 
10 00 78 00 3C 00 00 00 00 00 00 F0 00 3C 00 00 00 00 
00 00 F0 00 38 02 00 00 00 00 01 E0 00 38 06 00 F0 00 
00 01 E0 00 38 04 03 FC 08 00 01 E0 00 38 00 0F 9E 18 
00 C0 E0 00 38 00 1E 06 00 00 E0 E0 00 38 00 38 06 00 
00 C0 F0 00 3C 00 78 0E 00 00 00 F0 00 3C 00 E0 1C 00 
20 00 78 00 1F 01 C0 38 00 60 00 78 00 0F 01 80 70 00 
40 00 3C 00 07 01 C0 E0 00 00 00 3C 00 07 00 C0 C0 04 
00 00 0F 00 07 00 E0 C0 0E 00 00 07 80 07 00 70 C0 04 
00 00 03 FE 07 00 70 C0 00 00 00 01 FF 87 00 30 C0 00 
03 80 00 7F FF 00 70 E0 00 07 C0 00 00 FF 00 60 70 00 
0E F0 00 00 1F 00 E0 38 00 1C 7C 00 00 0E 00 C0 18 00 
18 3F 00 00 00 00 70 1C 00 30 0F 80 10 00 00 78 1C 00 
38 07 E0 18 00 00 3C 38 00 38 01 F0 38 00 00 1F F0 00 
1C 00 70 10 00 00 0F E0 00 1E 00 30 00 00 00 00 01 00 
0F 00 70 00 00 00 00 00 00 07 81 E0 00 00 20 00 00 60 
01 E7 C0 00 00 60 00 01 E0 00 FF 00 01 80 70 06 00 60 
60 3C 00 03 00 30 04 00 00 20 00 00 03 80 00 00 04 00 
00 00 18 00 00 00 00 06 00 00 00 30 00 00 00 00 04 00  
> def

end  % texturedict 

#####

texturedict begin

/fine-gravel 
<
00 00 00 00 00 00 00 00 80 00 00 00 00 20 00 00 00 00 
00 00 0C 00 00 10 00 20 00 08 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 80 
08 00 00 00 00 00 40 00 00 08 00 00 00 00 00 00 00 00 
00 00 60 04 00 00 00 08 00 00 00 00 00 00 00 00 00 02 
00 00 00 00 00 00 00 00 03 00 00 00 00 20 00 00 00 00 
00 00 00 00 00 00 00 00 00 80 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 F0 00 02 00 40 00 00 00 00 00 00 03 80 00 40 00 
00 00 00 00 00 00 00 00 00 01 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 01 00 04 00 
00 00 00 08 00 00 00 0F 00 00 00 00 00 00 00 00 86 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 20 00 1E 00 00 00 00 00 00 00 
00 0E 00 00 20 00 00 00 00 00 00 00 00 00 00 04 00 00 
00 00 00 00 00 00 00 00 00 08 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 20 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 30 00 20 00 00 1C 00 00 00 00 00 00 00 40 3C 
00 10 00 00 00 00 00 00 3C 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 40 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
30 00 40 00 00 00 00 00 00 10 00 00 00 00 00 00 00 00 
00 00 00 00 00 02 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 01 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 20 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 C0 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 E0 00 00 00 00 00 
00 00 80 E0 80 00 10 00 00 00 00 00 E0 00 40 00 08 00 
00 00 00 00 00 00 00 00 00 10 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 03 00 00 10 00 00 00 00 00 00 
  > def

end  % texturedict 

#####

texturedict begin

% following two are place-holding dummies
/light-mezzo  
  <> def
  
/heavy-mezzo
  <> def

/mezzo % image for light and heavy mezzotint pattern
< 
FF 00 FF 00 FF 00 FF 00 FF 9E 7E 1F A8 FF E1 FD F1 C7 
DC FC 3F F8 FF F8 FD FB 83 FC 78 7F F0 F0 F8 FC FF FF 
FF F0 7F F0 F0 78 7D 9F FF BF FC F1 F1 E0 7F 3F DF 87 
8F FF E1 F1 E7 FF 3F CF 07 E3 FF EF 73 C7 FF 1F 80 1F 
60 1F E7 03 C3 FE 1F 00 FE 70 07 E7 83 81 F8 1F 01 FC 
70 03 CF 83 C1 F0 7F 3F F8 7F 83 FF E7 C1 E3 FE 7F FC 
3F C7 FF FF E0 E7 FE 7F DE 1F FF C3 FF F0 EF FE 7F 0E 
3F FF 87 FF F8 FE 7E 7E 06 79 FF EE 7E 7C FC 3F FC 06 
F0 FC CC 3C 1E FE 3F FC 07 E0 61 CE 08 0E 7F 1F FC FF 
E0 01 DF 81 E4 7F 1F FF FF E7 83 FF C3 F0 7E 1F FF FF 
E7 E3 FF C7 F0 7C 3F 8F FF E7 FF FF FF FF FC 7F 8F FF 
E7 FF E3 FF FF F9 FF 8F F9 F7 FF C1 FE FF E3 FF 8F C1 
3F 9F C1 FC FE 07 E3 1F C0 3E 0F C1 F9 FC 1F E0 3F E0 
7E 07 F1 F1 F0 1F E0 FF F8 7C 0F F9 F1 E0 1F F1 FF FE 
7C CF FF F0 F0 3F FF F3 7E 7C EF FF F0 F8 78 FF F0 3E 
3F E0 3F E0 7F F8 7F FC 3E 3F F0 1F 80 7F F0 7F FE 3C 
9F F8 7F 8F FF F0 7C FF 79 8F FF FF 9F FF F0 78 7F F9 
87 FF F3 FF C1 F0 F8 7F F1 9F FF E1 FF E1 FB FC 7F F9 
FF 83 E0 FF F7 FF FF FF FF FF 01 E0 FF FF FF FF FF FF 
F7 39 E0 F8 FF FF 8F F7 FF E3 79 E0 F8 FE 1F 07 F3 DF 
63 3B E1 F8 7C 1E 37 FB C6 43 BF F1 FC 78 0F F7 FF 80 
43 FF F0 FC 78 1F F3 FF 80 63 FF FD FE 78 7F F8 7F 80 
60 FF BF FE 78 FF F8 7F 80 20 3F 0F FF F8 FF F8 7F F0 
00 3E 07 FF F8 FC 3C FF FE 03 FE 07 FF FD FC 1F FB FE 
FF FC 07 FE 5F FE 1F F0 7F FF FC 0F CE 0F FF 9F E0 3F 
FF FE 1F 8F 1F FF FF E0 7F FF 7F 3F 87 1F E3 FF F0 7F 
FF 1F FF 8F 9F C1 E1 F3 F9 CF 8F FF 0F 9F 03 F0 7F F9 
87 87 FF 0F FC 07 F8 7F F9 87 CF FF 0F F8 1F F8 7F F9 
07 CF 9F FF F8 7F FC 7F FC 0F FF 8F FF F8 FF FF FE 3E 
7F FE C3 FF FC F8 FF FC 1C 7F 78 E1 FF FF F8 7F FC 0C 
7F 20 E0 FF FF FC 7F FE 0E 1F 00 F9 F8 FF FC 7F FF 0E 
1F 81 FF F8 06 FC 20 3F FE 1F FF FF F8 00 FE 00 3F FC 
FF FF FF F0 73 FF 80 3F FD FF FF 7F E0 FF FF FC 3B F9 
FF FC 77 C1 FF CF FE 30 F9 F3 F8 F3 C7 C3 CF FF F8 79 
D3 C3 F9 FF 87 E0 7F FE 3D 83 CF F9 FE 07 E0 C7 FE 1F 
C3 9F FD F0 7F E7 E3 FC 3F FF 00 FF 00 FF 00 FF 00 FF 
> def

end  % texturedict 

######

texturedict begin

/med-mezzo
<
00 3F 00 3F 00 FC 00 FC 00 13 0D C7 E2 01 E0 18 64 66 
33 80 01 E0 30 43 18 00 F2 70 00 00 E0 78 03 88 11 F0 
30 03 80 C3 FC 03 8F 1F 80 10 01 E1 C7 CE C1 83 1F 02 
01 E0 E3 87 07 F1 83 8E 06 07 F0 73 07 00 31 87 06 06 
7F F0 73 0E 00 13 0E 00 C2 47 00 F1 84 30 0F 00 00 E0 
86 01 F1 80 70 07 80 C0 F1 86 01 E1 C1 F1 87 03 83 E1 
E3 C1 C3 C7 E3 80 07 07 C1 F3 E3 87 87 C3 80 07 0F 87 
B0 E3 07 08 07 00 4E 0F 07 80 63 03 98 0E 20 7C 07 07 
00 60 00 F8 0C 30 70 40 04 01 E0 18 1F C4 3E 01 E0 02 
47 C0 F8 03 C6 3F 03 E0 E2 47 EF EC 01 C7 0F 87 C3 E2 
46 30 84 40 C7 80 87 C3 C2 06 00 07 F0 0F 80 C3 81 C6 
07 00 07 E0 0F 00 E0 00 C2 07 87 C0 00 00 18 E0 10 E0 
01 C7 F0 06 00 18 E0 10 60 60 47 D8 3F 00 38 02 10 00 
F0 60 0C 7F 01 F8 0F 00 07 B8 60 0C 7F 39 E0 0F 01 07 
8E 30 0C E3 F8 E0 0F 1F 87 83 38 0C 60 78 E1 80 3F EF 
C1 18 CC 70 00 E3 C0 3E 79 C1 80 FC 30 00 43 C2 3C 01 
43 80 78 30 00 03 C7 08 00 07 00 30 F0 8C 01 C7 00 00 
0C 18 01 E0 78 01 C0 00 00 1C 3C 00 00 20 60 00 7F 18 
1C 1C 70 06 00 F0 00 73 FC 1E 0C F0 0F 01 F8 38 71 FC 
1F 8C E0 8F 81 FE 7C 78 5C 1F EC 43 DF E1 8F 9C 78 1C 
8F 78 43 7C 01 8C 0E 38 1D 80 70 44 10 01 80 1C 08 51 
E0 70 EE 00 03 80 F8 01 81 E0 70 FC 03 87 80 F0 01 87 
E0 38 E0 07 C7 18 F0 03 87 86 30 00 C6 60 38 C0 C3 87 
0E 00 00 F6 20 3C 00 E1 82 1E 02 18 FC 30 FC 01 E1 80 
1E 07 F8 38 30 F8 11 FF 1C 0F 07 F8 00 30 00 39 FF 04 
07 C0 18 00 20 00 38 03 06 03 E0 00 E0 30 06 18 01 00 
31 F0 00 FE 3C 7E 18 01 18 30 F1 80 70 3E 7F 98 0F 38 
1C F1 C0 00 0E 0F F0 0F 3C 18 C0 C6 00 0E 01 E0 07 FC 
88 00 C7 0F 0E 00 47 03 C5 80 00 0F 0F 8E 38 0F 80 01 
84 00 0F 83 8C 3C 0F 98 01 9C 38 0F C3 80 38 0D FC 1D 
BE 38 1F E1 80 38 88 1C 67 FE 38 FF 80 00 39 C0 0C C3 
6E 38 F0 00 3F F3 80 0D C0 40 78 C0 0C 3F C3 07 0D 00 
00 78 C0 1E 1C 03 9F C6 1C 00 00 61 0F 00 01 FC C6 1C 
30 00 30 07 00 60 F0 E2 06 38 80 38 00 00 78 01 E2 82 
79 E0 38 10 00 3C 01 C3 C6 71 E3 F1 FC 3C 1F C3 8B E6 
11 87 B1 CE 3E 18 E0 1B E0 00 3F 00 3F 00 FC 00 FC 00
> def

end  % texturedict 

######

texturedict begin

/coquille
< 
00 00 00 00 01 E0 00 00 00 00 03 80 00 00 70 00 00 00 
00 07 E0 00 00 3E 00 00 00 00 1F F8 00 00 1F 80 00 00 
00 7E 3E 00 00 07 80 00 00 01 FC 04 00 00 03 C0 00 00 
03 E0 00 00 00 01 E0 00 00 0E 00 00 00 00 00 40 00 00 
38 00 00 00 00 00 00 00 00 F0 00 00 00 00 00 00 00 00 
F0 00 00 1F 80 00 00 00 0E F0 00 01 FF 80 00 03 00 06 
F8 00 00 63 C0 00 03 80 00 F0 00 00 00 60 00 03 80 00 
00 00 00 00 30 00 01 80 00 00 00 00 00 0C 00 01 80 00 
00 00 00 00 03 E0 01 80 00 00 00 00 00 01 F0 00 80 00 
00 00 00 00 00 F0 00 C0 00 00 00 00 00 00 F0 00 70 00 
00 00 00 00 00 F0 00 38 00 03 E0 00 00 00 E0 00 1C 00 
01 F0 00 00 00 00 00 0C 00 00 E0 1C 00 00 00 00 1F 00 
00 C0 1F 00 00 00 00 1F F0 00 00 0F 80 00 00 00 30 7C 
00 00 07 80 00 00 00 60 1C 00 00 00 00 00 00 00 C0 0C 
00 00 00 00 00 00 00 80 04 00 00 00 00 00 00 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
00 00 00 00 1A 00 00 00 00 00 00 00 00 3E 00 00 00 00 
00 00 00 00 3C 00 00 00 00 00 00 00 00 7C 00 00 00 00 
00 00 00 00 7C 00 00 00 00 00 00 C0 00 FE 00 00 00 00 
3F FB C0 01 FF 80 00 00 00 01 FF E0 00 0F F0 00 00 00 
00 3F F0 00 00 0F F0 00 00 00 07 FF 00 00 03 F0 00 00 
00 01 FC 00 00 01 F0 1F C0 00 00 78 00 00 00 F0 1F E0 
00 00 70 00 00 00 E0 03 E0 00 00 78 00 00 00 E0 01 E0 
00 00 78 00 00 00 C0 01 E0 00 00 38 00 00 00 C0 00 E0 
00 00 0C 00 00 00 00 00 00 00 00 02 00 00 00 00 00 00 
00 00 01 00 00 00 00 00 00 00 00 00 40 00 00 00 00 00 
00 00 00 77 00 00 00 00 00 80 00 00 3F C0 00 00 00 00 
F0 00 00 01 F8 00 00 00 00 3F 00 00 00 1C 00 00 00 00 
0F 80 00 00 00 00 00 00 00 07 80 00 00 00 00 00 00 00 
03 80 00 00 00 00 00 1C 00 01 80 00 00 00 00 00 3E 00 
00 80 00 00 00 00 00 78 00 00 80 00 00 00 00 07 F0 00 
00 C0 00 1E 00 00 3F F0 00 00 F0 00 3F E0 00 7F F0 00 
00 FF 00 FF F0 00 7F 30 00 00 FF FF C0 00 00 70 00 00 
00 01 78 00 00 00 C0 00 00 00 00 00 00 00 01 80 00 00 
00 00 00 00 00 03 80 00 00 00 00 00 00 00 3F 00 00 00 
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  
  > def
  
end  % texturedict 

#####

% for all the following line styles - 
% stack: len width angle startx starty

ropedict begin
/arrow 
{ cnt 0 eq 
  { q blw w stroke Q [0 0 0 0] vc } if incrcnt
 blocksetup -.4 0 m .15 .4 L 0 0 L 
 .15 -.4 L blockend .2 0 m .2 .2 .25 .4 .35 .4 C
 .45 .4 .5 .2 .5 0 C .5 -.2 .45 -.4 .35 -.4 C
 .25 -.4 .2 -.2 .2 0 C blockend .1 0 m .2 .1 L 
 .2 -.1 L  blockfinish} def
end  % ropedict 

######

ropedict begin
/braid  
{ cnt 0 eq 
  { q blw w stroke Q [0 0 0 0] vc } if incrcnt
  blocksetup .5 .1 m .47 .24 L .4 .36 L 
  .3 .44 L .2 .4 L .1 .34 L 0 .2 L 
  -.16 -.08 L -.25 -.2 L -.35 -.24 L 
  -.43 -.2 L -.5 -.1 L -.47 -.24 L -.4 -.36 L 
  -.3 -.44 L -.2 -.4 L -.1 -.34 L 0 -.2 L
  .16 .08 L .25 .2 L .35 .24 L .43 .2 L
  blockfinish } def
end  % ropedict 

#####

ropedict begin
/crepe 
{ blocksetup -.5 .01 m -.35 .03 L -.2 .12 L
  .03 .33 L .15 .37 L .22 .32 L .38 .08 L 
  .44 .04 L .5 .01 L .5 -.01 m .35 -.03 L
  .2 -.12 L -.03 -.33 L -.15 -.37 L -.22 -.32 L 
  -.38 -.08 L -.44 -.04 L -.5 -.01 L blockfinish } def
end  % ropedict 

#####

ropedict begin
/snowflake 
{ blocksetup -.45 .5 m -.35 .3 L -.4 .25 L 
  blockend -.35 .5 m -.15 .5 L -.25 .4 L 
  blockend .15 .5 m .35 .5 L .25 .4 L blockend 
  .45 .5 m .45 .25 L .35 .3 L blockend 
  .45 -.25 m .45 -.5 L .35 -.3 L blockend
  .35 -.5 m .15 -.5 L .25 -.4 L blockend
  -.15 -.5 m -.35 -.5 L -.25 -.4 L blockend 
  -.45 -.5 m -.45 -.25 L -.35 -.3 L blockend 
  0 .45 m .1 .35 L 0 .25 L -.1 .35 L blockend 
  0 .08 m .15 .25 L .28 .08 L .25 .05 L
  -.25 .05 L -.28 .08 L -.15 .25 L blockend
  0 -.08 m -.15 -.25 L -.28 -.08 L -.25 -.05 L 
  .25 -.05 L .28 -.08 L .15 -.25 L blockend 
  0 -.25 m .1 -.35 L 0 -.45 L -.1 -.35 L 
  blockfinish } def
end  % ropedict 

######

ropedict begin
/teeth  
{ blocksetup -.5 -.28 m .5 -.28 L .5 -.3 L
  -.5 -.3 L blockend -.5 0 m -.35 .08 L 
  -.27 .17 L -.25 .25 L -.25 .5 L .25 .5 L
  .25 .25 L .27 .17 L .35 .08 L .5 0 L 
  blockfinish } def
end  % ropedict 

######

ropedict begin
/twowaves 
{ blocksetup 
  -.5 .33 m 0 .13 L .5 .33 L
  .5 .3 L 0 .1 L -.5 .3 L blockend
  -.5 -.1 m 0 -.3 L .5 -.1 L
  .5 -.13 L 0 -.33 L -.5 -.13 L closepath fill
  Q } def
end  % ropedict 

######

ropedict begin
/threewaves 
{ blocksetup -.5 .38 m 0 .23 L .5 .38 L 
  .5 .35 L 0 .2 L -.5 .35 L blockend
  -.5 .08 m 0 -.07 L .5 .08 L .5 .05 L
  0 -.1 L -.5 .05 L blockend -.5 -.25 m 
  0 -.4 L .5 -.25 L .5 -.28 L 0 -.43 L 
  -.5 -.28 L blockfinish } def
end  % ropedict 

######

ropedict begin
/wedge 
{ blocksetup 
 .5 .5 m 0 -1 rlineto -1 .5 rlineto blockfinish } def
end  % ropedict 

######

ropedict begin
/star
{ blocksetup 0 .5 m .3 -.4 L -.47 .15 L 
  .47 .15 L -.3 -.4 L blockfinish } def
end  % ropedict 

######

ropedict begin
/cartographer 
{ blocksetup -.5 .4 m -.5 .5 L .5 .5 L .5 0 L 
  0 0 L 0 -.4 L .5 -.4 L .5 -.5 L -.5 -.5 L 
  -.5 0 L 0 0 L 0 .4 L blockfinish } def
end  % ropedict 

######

ropedict begin
/checker 
{ blocksetup -.5 0 m -.5 .5 L 0 .5 L 0 0 L
  .5 0 L .5 -.5 L 0 -.5 L 0 0 L blockfinish } def
end  % ropedict 

#######

ropedict begin
/dot
{ blocksetup 0 0 .5 0 360 arc fill Q } def
end  % ropedict 

######

ropedict begin
/diamond 
{ blocksetup -.5 0 m .5 .5 rlineto .5 -.5 rlineto
  -.5 -.5 rlineto blockfinish } def
end  % ropedict 

#######

ropedict begin
/right-diagonal 
{ blocksetup -.5 -.5 m -.25 .5 L .5 .5 L
  .25 -.5 L blockfinish } def
end  % ropedict 

#######

ropedict begin
/left-diagonal
{ blocksetup -.25 -.5 m -.5 .5 L .25 .5 L 
  .5 -.5 L blockfinish } def
end  % ropedict 

########

ropedict begin
/rect 
{ blocksetup .5 .5 m 0 -1 rlineto -1 0 rlineto 
  0 1 rlineto blockfinish } def
end  % ropedict 

#######

ropedict begin
/ball 
{ q .05 w n translate rotate 
  scale 0 0 0.5 0 360 arc -.5 0 m
  -.4 .4 .4 .4 .5 0 C .4 -.4 -.4 -.4 -.5 0 
  C .5 0 L stroke n Q } def
end  % ropedict 

######

ropedict begin
/squiggle 
{ q .05 w n translate rotate 
  scale -.5 0 m .25 0 .75 .5 0 .5 C
  -.75 0.5 .75 -.5 0 -.5 C -.75 -.5 -.25 0 .5 0.0 
  C stroke n Q } def
end  % ropedict 

#######

ropedict begin
/swirl  
{ blocksetup -.5 0 m .25 0 .75 .5 0 .5 C
  -.75 .5 .75 -.5 0 -.5 C -.75 -.5 -.25 0 .5 0 C 
  -.25 0 -.75 .5 0 0.5 C .75 .5 -.75 -.5 0 -.5 C 
  .75 -.5 .25 0 0 0 C fill Q } def
end  % ropedict 

#######

ropedict begin
/zigzag
{ q .05 w n translate rotate 
  scale -.5 0 m 0 .5 L 0 -.5 L .5 0 L 
  stroke Q } def
end  % ropedict 

#######

ropedict begin
/roman 
{ q .05 w n translate rotate 
  scale -.5 0 m -.5 .4 L .3 .4 L
  .3 -.25 L -.1 -.25 L -.1 0 L .1 0 L
  .1 .25 L -.3 .25 L -.3 -.4 L .5 -.4 L
  .5 0 L stroke Q } def
end  % ropedict 

#######

ropedict begin
/heart 
{ blocksetup 0 -.5 m -.42 -0.1 L
  -.52 0 -.52 .2 -.42 .3 C -.3 .4 -.1 .4 0 .2 C
  .1 .4 .3 .4 .42 .3 C .52 .2 .52 0 .42 -.1 C
  blockfinish } def
end  % ropedict

#####
% code for doing tiff image generation
{currentfile fhimbuf1 readhexstring pop}

#####
{currentfile fhimbuf1 readstring pop}

#####
{currentfile fhimbuf1 readhexstring pop}
{currentfile fhimbuf2 readhexstring pop}
{currentfile fhimbuf3 readhexstring pop}

#####
{currentfile fhimbuf1 readstring pop}
{currentfile fhimbuf2 readstring pop}
{currentfile fhimbuf3 readstring pop}

#####
{currentfile fhimbuf1 readhexstring pop}
{currentfile fhimbuf2 readhexstring pop}
{currentfile fhimbuf3 readhexstring pop}
{currentfile fhimbuf4 readhexstring pop}

#####
{currentfile fhimbuf1 readstring pop}
{currentfile fhimbuf2 readstring pop}
{currentfile fhimbuf3 readstring pop}
{currentfile fhimbuf4 readstring pop}

#####
/fhimbuf1 ^0 string def
^1 ^2 ^3 ^4 ^5
#####
separationimage
#####
/fhimbuf1 ^0 string def
^1 ^2 ^3 ^4 ^5
#####
image
#####
^A vc
/fhimbuf1 ^0 string def
^1 ^2 false ^4 ^5
#####
imagemask
#####
% colorimage: width height bits matrix proc multi ncomp colorimage --
/fhimbuf1 ^0 string def
/fhimbuf2 ^0 string def
/fhimbuf3 ^0 string def
/fhimbuf4 ^0 string def
^1 ^2 ^3 ^4 ^5 true ^6
#####
colorimage
#####
% customcolorimage: width height bits matrix proc [c m y k (colorname)] customcolorimage --
/fhimbuf1 ^0 string def
^1 ^2 ^3 ^4 ^5 [^8 (^9)]
#####
customcolorimage
#####
%%BeginBinary: ^7
#####
%%EndBinary
#####
% stinking OPI comments, which, contrary to natural law,
% start with but a single percent. note that
% we don't bother putting out the ALDImageGrayMap at this point.
ImMatrix currentmatrix pop	% save the current mtx...
origmtx setmatrix			% and set the "default" one for OPI happiness
%ALDImageFileName: ^Z
%ALDImageDimensions: ^1 ^2
%ALDImageCropRect: ^3 ^4 ^5 ^6
%ALDImagePosition: ^7
%ALDImageResolution: ^A ^B
%ALDImageColor: ^C (^D)
%ALDImageType: ^E ^F
%ALDImageTransparency: ^G
%%BeginObject: image
ImMatrix setmatrix			% restore the real matrix now

#####
%%EndObject

#####
[0 0 0 0] vc ^0 ^1 ^2 ^3 rectfill

#####

% code for drawing ps procs to screen
AltsysDict begin
^0 eomode
{^1}stopped pop
end

#####

% code for drawing pat lines to screen
AltsysDict begin
{^1 <^0> pS}stopped pop
end

#####

% code for drawing pat fills to screen
AltsysDict begin
^2 eomode
{^1 <^0> pF}stopped pop
end

#####
%------------------------------
% code for doing tiled fills.
%------------------------------

% define a dict to hold all our tiles.
/fhtiledict ^0 dict def

#####
% define a tiled fill (begin)
% note: the pattern code is designed to keep the
% patterned anchored to its own bbox. we want it
% anchored to 0,0. so we fake all tiles to
% be 0,0 based by preceding our stuff with a translate.

fhtiledict begin
	10 dict
	begin
		/PatternType 1 def
		/PaintType 1 def	% colored
		/Multi 1 def		% slow...
		/TilingType 1 def
		/BBox [0 0 ^1 ^2] def
		/XStep ^1 def
		/YStep ^2 def
		/PaintProc {
			pop		% ignore the font dict
			AltsysDict begin
			save
			^3 neg ^4 neg translate
			% ... PS code for tile goes here
#####
(
#####
) cvx exec
#####
% define a tiled fill (end)
			% ... PS code for tile goes here
			restore
			end
		}bdf
		%/Implementation may be inserted by PS
		%/PatData will be inserted by us
	currentdict		% leave on stack
	end 			% tile pat dict
	/tile^0 xdf		% define in fhtiledict
end % fhtiledict

#####
% output a tiled fill
% note: this needs to be enclosed in save/restore.
	fhtiledict /tile^0 get 
	^5 PATmp PATsp
	/clipper load /eoclip load eq PATfill

#####
setcolorscreen

#####
% output at the start of Mac printing to undo the md state
initmatrix newpath initclip
1 setlinewidth 0 setlinecap 0 setlinejoin
[] 0 setdash 0 setgray 10 setmiterlimit

#####
% here are some strings for Mac fontreencoding...
MacVec 256 array copy

#####
% here are some strings for Mac fontreencoding...
dup ^0 /^1 put

#####
% here are some strings for Mac fontreencoding...
^0 /^1 def

#####
% here are some strings for Mac fontreencoding...
md begin BDFontDict begin userdict begin

#####
% here are some strings for Mac fontreencoding...
end end end

#####
% here are some strings for Mac fontreencoding...
/f^1 /|______^0 dup RF findfont def

#####
% here is the header for checking PS code entered by the user for fill and line...
%!PS-Adobe-2.0 EPSF-1.2
%%BoundingBox: 0 0 72 72 
/_VrtSaveObj1 save def

	% set up some counters/flag
	50 dict begin 
	/_VrtDictCount countdictstack def % set up dict stack count
	/_VrtOperandCount count 1 sub def % set up operand stack count
	/_VrtsaveCnt 0 def	% set up save count 
	/_VrtgsaveCnt 0 def % set up gsave count
	/_VrtdidRestore 0 def % set up a flag to flag restores
	/_VrtbadSaveCnt 0 def % set to indicate a bad save/restore condition
	/_VrtbadGSAVECnt 0 def % set to indicate a bad gsave/restore condition
	

	% redefine some operators to do our checking
	% save
	% increment the save count and do a save
	/save 
		{/_VrtsaveCnt _VrtsaveCnt 1 add def save} bind def

	% restore	
	% don't let some one restore too many times
	% set a didRestore flag for us to know if the gsaveCnt is correct		
	/restore 
		{_VrtsaveCnt 1 ge
			{restore /_VrtsaveCnt _VrtsaveCnt 1 sub def /_VrtdidRestore 1 def}
			{/_VrtbadSaveCnt 1 def pop (in PS from user) errordict /invalidrestore get exec}
			ifelse
		} bind def
		
	% since the restore effectively does a grestoreall up to the last save
	% this count is only correct when there have been no restores called.
	% it should never be less than zero so we keep track of it and check it for that later	
	/gsave
		{/_VrtgsaveCnt _VrtgsaveCnt 1 add def gsave} bind def
	/grestore
		{_VrtgsaveCnt 1 ge
			{grestore /_VrtgsaveCnt _VrtgsaveCnt 1 sub def}
			{/_VrtbadGSAVECnt 1 def}
		 ifelse
		} bind def

	% redef these calls to set the error code to watch out for bad operators	
	/makeSyntaxError {errordict /syntaxerror get exec} def

	/initgraphics {(initgraphics operator should not be called in User PS)
					makeSyntaxError} def
					
	/showpage {(showpage operator should not be called in User PS)
					makeSyntaxError} def
					
	/banddevice {(banddevice operator should not be called in User PS)
					makeSyntaxError} def
					
	/clear {(clear operator should not be called in User PS)
					makeSyntaxError} def
					
	/cleardictstack {(cleardictstack operator should not be called in User PS)
					makeSyntaxError} def
					
	/copypage {(copypage operator should not be called in User PS)
					makeSyntaxError} def
					
	/erasepage {(erasepage operator should not be called in User PS)
					makeSyntaxError} def
					
	/exitserver {(exitserver operator should not be called in User PS)
					makeSyntaxError} def
					
	/framedevice {(framedevice operator should not be called in User PS)
					makeSyntaxError} def
					
	/grestoreall {(grestoreall operator should not be called in User PS)
					makeSyntaxError} def
					
	/initclip {(initclip operator should not be called in User PS)
					makeSyntaxError} def
					
	/initmatrix {(initmatrix operator should not be called in User PS)
					makeSyntaxError} def
					
	/quit {(quit operator should not be called in User PS)
					makeSyntaxError} def
					
	/renderbands {(renderbands operator should not be called in User PS)
					makeSyntaxError} def
					
	/setglobal {pop (setglobal operator should not be called in User PS)
					makeSyntaxError} def
					
	/setpagedevice {pop (setpagedevice operator should not be called in User PS)
					makeSyntaxError} def
					
	/setpagedevice {pop (setpagedevice operator should not be called in User PS)
					makeSyntaxError} def
					
	/startjob {pop pop (startjob operator should not be called in User PS)
					makeSyntaxError} def
					
/_VrtSaveObj2 save def	
/_VrtsaveCnt 0 def

#####
% this is the trailer code for checking users ps for lines and fills
	%first check the stacks
	count _VrtOperandCount ne {
				count _VrtOperandCount sub {pop} repeat
				(operand stack was not returned to original state in User PS)
				makeSyntaxError
				} if 
				
	_VrtDictCount countdictstack ne {
				countdictstack _VrtDictCount sub {end} repeat
				(dictionary stack were not returned to original state in User PS)
				makeSyntaxError
				} if
				
	_VrtbadSaveCnt 0 gt 
				{(too many restore calls in User PS) makeSyntaxError} if
				
	_VrtbadGSAVECnt 0 gt 
				{(too many grestore calls in User PS) makeSyntaxError} if 

	% if there were no restores done, make sure there were no saves, and enough restores			
	_VrtdidRestore 0 eq {
					_VrtsaveCnt 0 gt 
						{(missing restore call(s) in User PS) makeSyntaxError} if 
					_VrtgsaveCnt 0 gt 
						{(missing grestore call(s) in User PS) makeSyntaxError} if
					} if 

	
    _VrtSaveObj2 systemdict /restore get exec
	% take our dict off the stack
	end
	_VrtSaveObj1 restore

#####

% code output before a plate from a DCS file.
% the problem: a DCS file probably uses
% 'image' to render that plate, but we cleverly
% redefine that to only work on the black plate.
% since DCS is pre-separated, we just nork it
% out and temporarily define image and colorimage
% back to their original defs.

/image{_image}bind def
/_colorimage defed { /colorimage { _colorimage } bind def } if

% note that this is output AFTER the eps begin operator
% so that the change will be undone by the 'save'...

#####

% code output just to rotate the page 90 degrees.
% this is used after outputting PPD code if
% the user has selected Landscape.

-90 rotate ^4 neg 0 translate	% ^4 == right side of paper

#####

%------------------------------------------------------------------------
% pattern functions
% these are used to do patterned fills, and maybe tiles and textures too.
%------------------------------------------------------------------------

% the level 2 def -- use only if makepattern IS defined
/makepattern defed /xt xdf
xt not {/yt save def} if

	/PATmp{
		exch dup length 3 add dict copy
		begin
		currentdict /Multi known not {/Multi 1 def} if
		Multi 1 ne {
			/UserProc /PaintProc load def
			/PaintProc {
				begin
					0 1 Multi 1 sub {
						PaintColors 1 index get PATsc
						PaintData exch get
						gsave currentdict UserProc grestore
					}for 
				end
			} bdf
		} if
		currentdict
		end
		exch makepattern
	}bdf

	/PATsp{
		dup /PaintType get 2 eq
		{
			exch aload length 4 eq
			{5 -1 roll}
			{spots exch get 0 4 getinterval aload pop
			 4 {4 index mul 4 1 roll} repeat 6 -2 roll pop}ifelse			
			[/Pattern /DeviceCMYK] setcolorspace
		}if
		setpattern
	}bdf

	/PATfill{{{eofill}fp}{{fill}fp}ifelse}bdf
	/PATprestroke{}bdf
	/PATstroke{stroke}bdf

xt not {yt restore} if
% end of level 2 def
% begin of level 1 def
xt {/yt save def} if

	% modmtx tiletype -- tilemtx
	/PATtcalc{
		% types 2 and 3 not supported
		gsave
		exch concat					% tiletype
		matrix currentmatrix exch	% mtx2 tiletype
		2 ne {
			% distort size to be integral number of device pixels
			dup 4 get exch dup 5 get exch
			XStep 0 dtransform round exch round exch
			XStep div exch XStep div exch
			0 YStep dtransform round exch round exch
			YStep div exch YStep div exch
			7 -3 roll astore
		} if
		grestore
	}bdf

	% dict matrix --
	/PATmp{
		exch 				% matrix dict
		dup 				% matrix dict dict
		length 8 add		% matrix dict len'
		dict copy			% matrix dict2
		begin				% matrix
			% mtx to install when painting pat
			TilingType PATtcalc % mtx2
			/PATcurrentMtx xdf	% defines in the pat dict
			currentdict /Multi known not {/Multi 1 def} if
			% font dict defs
			/FontType 3 def
			% dummy encoding vector
			/Encoding 256 array def
			3 string 0 1 255 
			{Encoding exch dup 3 index cvs cvn put} for pop
			/FontMatrix matrix def
			/FontBBox BBox def
			/BuildChar {
				mark 3 1 roll
				exch begin
					Multi 1 ne {PaintData exch get}{pop}ifelse
					PaintType 2 eq Multi 1 ne or
					{XStep 0 FontBBox aload pop setcachedevice}
					{XStep 0 setcharwidth}ifelse
					currentdict		% mark [paintdata] dict
					/PaintProc load	% mark [paintdata] dict paintproc
				end
				gsave exec grestore
				cleartomark
			}bdf
			currentdict	% leave conveniently on stack.
		end
		/foo exch
		definefont
	}bdf

	% pattern -- (if not type 2)
	% color pattern -- (if type 2)
	/PATsp{
		/PATcurrent xdf
		PATcurrent /PaintType get 2 eq
		{/PATcolor xdf}if
	}bdf

	% -- nw nh px py
	/PATpcalc{
		PATcurrent begin
		gsave
			PATcurrentMtx setmatrix
			BBox aload pop pop pop translate
			pathbbox
		grestore
		YStep div ceiling 4 1 roll
		XStep div ceiling 4 1 roll
		YStep div floor 4 1 roll
		XStep div floor 4 1 roll
		2 index sub cvi abs
		exch 3 index sub cvi abs exch
		4 2 roll
		YStep mul exch XStep mul exch
		end
	}bdf
	
	% isEO --
	/PATfill{
		{{eoclip}fp}{{clip}fp}ifelse
		PATpcalc				% nw nh px py
		newpath
		PATcurrent dup begin
		setfont
		PATcurrentMtx setmatrix
		PaintType 2 eq {PATcolor vc} if
		3 index string			% nw nh px py str
		0 1 Multi 1 sub {		% nw nh px py str src
			3 index 3 index moveto
			Multi 1 ne {dup PaintColors exch get vc} if
			0 1 7 index 1 sub {	% nw nh px py str src i
				2 index 		% nw nh px py str src i str
				exch 			% nw nh px py str src str i
				2 index put
			} for
			pop					% nw nh px py str
			3 index				% nw nh px py str nh
			{
				currentpoint	% nw nh px py str cx cy
				2 index show
				YStep add moveto
			}repeat
		}for
		5 {pop} repeat		
		end
	}bdf

	/PATprestroke{strokepath}bdf
	/PATstroke{false PATfill}bdf

xt {yt restore} if
% end of level 1 def

#####	very important to leave this as the final item!

